#ifndef _ACCUMEXPREDUCTION_H
#define _ACCUMEXPREDUCTION_H

#include "Instruction.h"
#include "Type.h"
#include "Unit.h"
#include "BasicBlock.h"
#include <set>
#include <unordered_set>
#include <vector>
class AccumExpReduction {
    Unit *unit;
    std::map<SymbolEntry*,std::pair<Instruction*,int>> expOps;
    std::map<int,SymbolEntry*> numberOp_map;
    void insertBefore(Instruction *, Instruction *);
    std::vector<Instruction*> expInsts;
    void findExp(Function *func);
    bool isValid(Instruction* instr);
    int getOperator(int opcode);
    void simplifyExp(int res, BasicBlock *bb);
    void continAdd(Function *func);
    int rvalCheck();
    Operand* init=nullptr;
    Operand* end=nullptr;

  public:
    AccumExpReduction(Unit *_unit) : unit(_unit) {}
    void execute();
};

#endif