#ifndef __HOISTING_H__
#define __HOISTING_H__
#include "LoopDetection.h"
#include "Unit.h"
#include <list>
#include <memory>
#include <unordered_set>
#include <vector>

class Hoisting {
    std::unordered_set<SymbolEntry *> defInLoop;
    std::vector<std::pair<BasicBlock *, Instruction *>> invariant;
    LoopDetection* detector;
    int areaCount;
    void findInvariants(blockSet *);
    void findDef(blockSet *);
    void buildPrehead();
    void appendTo();
    void moveInvariantsOut(blockSet *);
    bool definedOut();
    bool definedIn_invariant();
    bool FunctionCheck(CallInstruction *call);
    BasicBlock *buildBB();
    Unit *unit;

  public:
    Hoisting(Unit *unit) : unit(unit) {}
    void execute();
};

#endif