#include "FunctionInline.h"

// bool isdebug = true;
// bool isdebug = false;

bool FunctionInline::canbeInlined(SymbolEntry* funcSE) {
    // return false;
    // if(isdebug) std::cout << "decide begin." << std::endl;
    // SymbolEntry* funcSE = func->getSymPtr();
    // std::cout << "get entry." << std::endl;
    if (((IdentifierSymbolEntry*)funcSE)->isSysy() 
        || ((IdentifierSymbolEntry*)funcSE)->getName() == "llvm.memset.p0.i32") {
        // if(isdebug) std::cout << "is sysY." << std::endl;
        return false;
    }
    // if(isdebug) std::cout << "not sysY." << std::endl;
    
    //统计inst数量:
    int instNum = 0;
    Function* func = ((IdentifierSymbolEntry*)funcSE)->getFunction(); //在Function类的构造函数里加上对funcSE的func设置;
    if(func->getcsseflag()){
        return true;
    }
    // if(isdebug) std::cout << "get function." << std::endl;
    // if(isdebug) std::cout << "Block size: " <<  func->getBlockList().size() << std::endl;
    for (auto bb: func->getBlockList()) {
        for(auto inst = bb->begin(); inst != bb->end(); inst = inst->getNext()) {
            if(inst->isCall()) {
                if(((IdentifierSymbolEntry*)
                    (((CallInstruction*)inst)->getSymEntry()))->getFunction()
                     == func) { //递归no!；
                     return false;
                }
                // if(((IdentifierSymbolEntry*) //Todo: 暂时不支持含有"llvm.memset.p0.i32"调用的函数;
                //     (((CallInstruction*)inst)->getSymEntry()))->getName() 
                //      == "llvm.memset.p0.i32") {
                //         return false;
                // }
            }
            if((++instNum) > cfg_func_size) {
                return false;
            }
        }
    }

    //检查返回类型和参数类型及数量:
    // Type* retType = ((FunctionType*)(funcSE->getType()))->getRetType();
    // if(retType->isFloat()) { //Todo: 暂时不支持浮点返回类型;
    //     return false;
    // }
    std::vector<Type*> paramlist = ((FunctionType*)(funcSE->getType()))->getParamsType();
    for(auto param: paramlist) {
        // if(param->isArray()) { //Todo: 暂时不支持数组参数;
        //     return false;
        // }
        // if(param->isFloat()) { //Todo: 暂时不支持浮点参数;
        //     return false;
        // }
    }
    // if(isdebug) std::cout << "paramlist.size: " << paramlist.size() << std::endl;
    if(paramlist.size() >= this->cfg_param_nums) {
        // if(isdebug) std::cout << "paramlist.size()" << paramlist.size() << std::endl;
        return true;
    }
    // if(isdebug) std::cout << "func size: " << instNum << std::endl;
    if(instNum <= this->cfg_func_size) {
        return true;
    }
    return false;
}

void FunctionInline::extractCaller() {
    for(auto func: this->unit->get_functions()) {
        for(auto bb: func->getBlockList()) {
            for(auto inst = bb->begin(); inst != bb->end(); inst = inst->getNext()) {
                if(inst->isCall()) {
                    // if(isdebug) std::cout << "detect callinst!" << std::endl;
                    Function* func = ((IdentifierSymbolEntry*)
                            (((CallInstruction*)inst)->getSymEntry()))
                            ->getFunction(); //ADD getSymEntry() in Instruction.h;
                    // if(isdebug) std::cout << "get func." << std::endl;
                    if(std::count(callee.begin(), callee.end(), func) != 0) {
                        // if(isdebug) std::cout << "alread detected." << std::endl;
                        int index = std::find(callee.begin(), callee.end(), func) - callee.begin();
                        this->caller[(CallInstruction*)inst] = index;
                    } else if(this->canbeInlined((SymbolEntry*)
                                    (((CallInstruction*)inst)->getSymEntry()))) {
                        // if(isdebug) std::cout << "can be inlined." << std::endl;
                        //callee.push_back(func);
                        callee.push_back(((IdentifierSymbolEntry*)(SymbolEntry*)
                                    (((CallInstruction*)inst)->getSymEntry()))->getFunction());
                        this->caller[(CallInstruction*)inst] = callee.size() - 1;
                    } else {
                        // if(isdebug) std::cout << "can not be inlined." << std::endl;
                        continue;
                    }
                }
                
            }
        }
    }
}

void FunctionInline::cloneFunc(CallInstruction* call) {


    // if(isdebug) std::cout << "func clone begin." << std::endl;
    //call_bb -> exit_bb:
    BasicBlock* call_bb = call->getParent();
    BasicBlock* exit_bb = new BasicBlock(call_bb->getParent());
    Instruction* inst_begin = call->getNext();
    Instruction* inst_end = call_bb->rbegin();
    Instruction* head = exit_bb->begin()->getPrev();
    head->setNext(inst_begin);
    inst_begin->setPrev(head);
    inst_end->setNext(head);
    head->setPrev(inst_end);
    call->setNext(call_bb->begin()->getPrev());
    call_bb->begin()->getPrev()->setPrev(call);
    for (Instruction* inst = inst_begin; inst != inst_end; inst = inst->getNext()) {
        inst->setParent(exit_bb);
    }
    while(call_bb->getNumOfSucc() != 0) {
        auto succ = *(call_bb->succ_begin());
        succ->removePred(call_bb);
        call_bb->removeSucc(succ);
        succ->addPred(exit_bb);
        exit_bb->addSucc(succ);
        // for (auto inst = succ->begin(); inst != succ->end(); inst = inst->getNext()) {
        //     if (inst->isPhi()) {
        //         ((PhiInstruction*)inst)->changeSrcBlock(call_bb, exit_bb); //ADD changeSrcBlock in Instruction.h;
        //     }
        // }
    }

    // if(isdebug) std::cout << "call_bb -> exit_bb finshed." << std::endl;

    //copy func_inline:
    Function* func_inline = callee[caller[call]];
    auto ret = call->getDef();
    auto params = call->getUse();

    BasicBlock* entryBlock;
    
    std::vector<BasicBlock*> retBlocks;
    // std::vector<Operand*> retOperands;

    std::map<Instruction*, Instruction*> gepMap;
    std::map<Instruction*, Instruction*> phiMap;
    std::map<Instruction*, Instruction*> brMap;
    std::map<Instruction*, Instruction*> cbrMap;

    //使用phi指令处理返回值，与DCE兼容:
    std::map<Operand*, BasicBlock*> ret2bb;
    
    std::map<Operand*, Operand*> paramMap; // <addr, realParam>
    int paramIndex = 0;
    std::map<Operand*, Operand*> operandMap;
    std::map<BasicBlock*, BasicBlock*> basicBlockMap;
    // if(isdebug) std::cout << "travel function begin." << std::endl;
    for(BasicBlock* oldBB: func_inline->getBlockList()) {
        BasicBlock* newBB = new BasicBlock(call_bb->getParent());
        // call_bb->getParent()->insertBlock(newBB);
        basicBlockMap[oldBB] = newBB;
        // if(isdebug) std::cout << "travel block: " << oldBB->getNo() <<std::endl;
        //oldBB在这儿会出现NULL的情况？
        // if(oldBB->getNo() > 100000 || oldBB->getNo() < -100000) {
        //     continue;
        // }
        for (auto oldInst = oldBB->begin(); oldInst != oldBB->end(); oldInst = oldInst->getNext()) {
            if(oldInst->isRet()) { //no need to copy;
                // if(isdebug) std::cout << "find ret." << std::endl;
                auto oldUselist = ((RetInstruction*)oldInst)->getUse();
                Instruction* newInst1;
                if (oldUselist.size() != 0) { // 0 or 1;
                    auto oldUse = oldUselist[0];
                    // if(isdebug) std::cout << oldInst->getInstName() << " has return type: "<< oldUse->getType()->toStr() << ": "<< oldUse->toStr() <<std::endl;
                    Operand* newUse;
                    if (oldUse->isGlobal() || oldUse->isConst()) {
                        newUse = oldUse;
                    } else if (oldUse->isParam()) { //params;
                        newUse = params[oldUse->getParamNo()];
                        //(dynamic_cast<IdentifierSymbolEntry*>(newUse->getSymbolEntry()))->Param2Local();
                        // if(isdebug) std::cout << newUse->toStr() <<std::endl;
                    } else {
                        if (operandMap.count(oldUse)) {
                            newUse = operandMap[oldUse];
                        } else {
                            newUse = new Operand(new TemporarySymbolEntry(
                                oldUse->getType(), SymbolTable::getLabel()));
                            operandMap[oldUse] = newUse;
                        }
                    }
                    
                    // Operand* retop = new Operand(new TemporarySymbolEntry(
                    //         oldUse->getType(), SymbolTable::getLabel()));
                    
                    // if(isdebug) std::cout << "ret: ";
                    // if(isdebug) std::cout << ret->getType()->toStr() << ": "<< ret->toStr() <<std::endl;
                    Operand* temp = new Operand(new ConstantSymbolEntry(
                            oldUse->getType(), 0));
                    // if(isdebug) std::cout << "temp: ";
                    // if(isdebug) std::cout << temp->getType()->toStr() << ": "<< temp->toStr() <<std::endl;

                    // if(isdebug) std::cout << "newUse: ";
                    // if(isdebug) std::cout << newUse->getType()->toStr() << ": "<< newUse->toStr() <<std::endl;
                    
                    Operand* ret_copy = new Operand(new TemporarySymbolEntry(
                            ret->getType(), SymbolTable::getLabel()));
                    // newInst1 = new BinaryInstruction(BinaryInstruction::ADD, ret, newUse, temp);
                    newInst1 = new BinaryInstruction(BinaryInstruction::ADD, ret_copy, newUse, temp);
                    // std::cout << ret_copy->toStr();
                    ret2bb[ret_copy] = newBB;
                    
                    newBB->insertBack(newInst1);
                    newInst1->setParent(newBB);

                    // if(isdebug) std::cout << oldInst->getInstName() << " :has been changed to " << newInst1->getInstName() << std::endl;
                    // retOperands.push_back(retop);//record returns;
                }
                Instruction* newInst2 = new UncondBrInstruction(exit_bb);
                newBB->insertBack(newInst2);

                //临时处理一下insertBack的bug:
                // newInst2->setPrev(newInst1);

                newInst2->setParent(newBB);
                retBlocks.push_back(newBB);
                //if(isdebug) std::cout << "success managing ret." << std::endl;
                continue;
            } 

            Instruction* newInst = oldInst->copy1(); //在instruction.h中为每一种指令添加一个浅拷贝;
            // if(isdebug) std::cout << "an inst was copied." << std::endl;

            // if(newInst->isAlloc()) { //mem2reg;
            //     if((dynamic_cast<IdentifierSymbolEntry*>
            //         (dynamic_cast<AllocaInstruction*>(newInst)->getSymbolEntry()))->isParam()) {
            //             paramMap[dynamic_cast<AllocaInstruction*>(newInst)->getDef()] = params[paramIndex++];
            //             std::cout << dynamic_cast<AllocaInstruction*>(newInst)->getDef()->toStr()<< "<=>" << params[paramIndex-1]->toStr() << std::endl;
            //             //continue;
            //     }
                
            // } else if(newInst->isStore()) {
            //     if(paramMap.count(dynamic_cast<StoreInstruction*>(newInst)->getDef()) 
            //             && (dynamic_cast<StoreInstruction*>(newInst)->getUse())[0]->isParam()) {
            //         std::cout << (dynamic_cast<StoreInstruction*>(newInst)->getDef())->toStr()<< "<= store <=." << std::endl;
            //         continue;
            //     } else if(paramMap.count(dynamic_cast<StoreInstruction*>(newInst)->getDef())) {
            //         paramMap[dynamic_cast<StoreInstruction*>(newInst)->getDef()] 
            //         = (dynamic_cast<StoreInstruction*>(newInst)->getUse())[0];
            //     }
            //     continue;
            // } else if(newInst->isLoad()) {
            //     if(paramMap.count((dynamic_cast<LoadInstruction*>(newInst)->getUse())[0])) {
            //         operandMap[(dynamic_cast<LoadInstruction*>(newInst)->getDef())] 
            //         = paramMap[(dynamic_cast<LoadInstruction*>(newInst)->getUse())[0]];
            //         std::cout << (dynamic_cast<LoadInstruction*>(newInst)->getDef())->toStr()<< "<= load <=" 
            //             << paramMap[(dynamic_cast<LoadInstruction*>(newInst)->getUse())[0]]->toStr() <<  std::endl;
            //         continue;
            //     }
            // }

            switch (newInst->getInstType())
            {
            case Instruction::UNCOND: //将enum改为public;
                brMap.insert({oldInst, newInst});
                // if(isdebug) std::cout << "UNCOND." << std::endl;
                break;
            case Instruction::COND:
                cbrMap.insert({oldInst, newInst});
                // if(isdebug) std::cout << "COND." << std::endl;
                break;
            case Instruction::PHI:
                phiMap.insert({oldInst, newInst});
                break;
            case Instruction::GEP:
                gepMap.insert({oldInst, newInst});
                // if(isdebug) std::cout << "GEP." << std::endl;
                // break;
            // case Instruction::ALLOCA:
                //break;
            // case Instruction::STORE:
            //     break;
            // case Instruction::LOAD:
            //     break;
            default:
                // if(isdebug) std::cout << newInst->getInstName() << std::endl;
                auto oldDef = oldInst->getDef();
                auto oldUses = oldInst->getUse(); //Store语句的getUse()写错了，不知道会不会给其他地方造成问题。
                if (oldDef) {
                    // if(isdebug) std::cout << newInst->getInstName() << " oldDef: " << oldDef->toStr() << std::endl;
                    Operand* newDef;
                    if(oldDef->isGlobal() || oldDef->isConst()) {
                        newDef = oldDef;
                    } else if (operandMap.count(oldDef)) {
                        newDef = operandMap[oldDef];
                    } else if(oldDef->isParam()){
                        newDef = params[oldDef->getParamNo()];
                        //(dynamic_cast<IdentifierSymbolEntry*>(newDef->getSymbolEntry()))->Param2Local();
                    } else {
                        newDef = new Operand(new TemporarySymbolEntry(
                            oldDef->getType(), SymbolTable::getLabel()));
                        operandMap[oldDef] = newDef;
                    }
                    newInst->replaceDef(newDef); //给store指令添加一个replaceDef函数，这儿不用为op设置def！！！否则会破坏mem2reg；
                    // std::cout<<newInst->getInstName()<<" "<<newInst->getDef()->toStr()<<std::endl;
                    // if(isdebug) std::cout << newInst->getInstName() << " :has changed Def to: " << newDef->toStr() << std::endl;
                }
                for (auto oldUse : oldUses) {
                    Operand* newUse;
                    if (oldUse->isGlobal() || oldUse->isConst()) {
                        newUse = oldUse;
                        // if(isdebug) std::cout << "oldUse->isGlobal() || oldUse->isConst():" << oldUse->toStr() << std::endl;
                    } else if (oldUse->isParam()) { //isParam识别不到??已解决;
                        newUse = params[oldUse->getParamNo()];
                        //(dynamic_cast<IdentifierSymbolEntry*>(newUse->getSymbolEntry()))->Param2Local(); //在SymbolEntry中添加Param2Local()这个函数；
                        // if(isdebug) std::cout << newUse->toStr() <<std::endl;
                        // if(isdebug) std::cout << oldUse->toStr() << " :is param [" << oldUse->getParamNo() << "]" <<std::endl;
                        // if(isdebug) std::cout << "changed to: " << newUse->toStr() << std::endl;
                    } else {
                        //Operand* newUse;//重定义啦啊啊啊啊。。
                        if (operandMap.count(oldUse)) {
                            newUse = operandMap[oldUse];
                            // if(isdebug) std::cout << oldUse->toStr() << " :has being Maped to " << newUse->toStr() <<std::endl;
                        } else {
                            newUse = new Operand(new TemporarySymbolEntry(
                                oldUse->getType(), SymbolTable::getLabel()));
                            operandMap[oldUse] = newUse;
                        }
                    }
                    //if(isdebug) std::cout << "we will replaceUse." << std::endl;
                    newInst->replaceUse(oldUse, newUse);
                    //if(isdebug) std::cout << "replaceUse succeed!" << std::endl;
                    // if(newInst->isCall()) {
                    //     if(isdebug) std::cout << (newInst->getUse())[0]->toStr() << std::endl;
                    //     if(isdebug) std::cout << (newInst->getUse())[1]->toStr() << std::endl;
                    //     if(isdebug) std::cout << (newInst->getUse())[2]->toStr() << std::endl;
                    //     if(isdebug) std::cout << (newInst->getUse())[3]->toStr() << std::endl;
                    // }

                }
                // if(isdebug) std::cout << newInst->getInstName() << " :has changed Use." << std::endl;
                
                break;
            }
            if(newInst->isAlloc()) {
                // SymbolEntry* se = newInst->getDef()->getSymbolEntry();
                // // (dynamic_cast<AllocaInstruction*>(newInst))->replaceSymbolEntry(se); 
                if((dynamic_cast<IdentifierSymbolEntry*>
                    (dynamic_cast<AllocaInstruction*>(newInst)->getSymbolEntry()))->isParam()) {
                        (dynamic_cast<IdentifierSymbolEntry*>
                            (dynamic_cast<AllocaInstruction*>(newInst)->getSymbolEntry()))
                            ->Param2Local();
                        
                        // if(isdebug) std::cout << "Param2Local: " << (dynamic_cast<AllocaInstruction*>(newInst)->getSymbolEntry())->toStr() << std::endl;
                    }
            }
            
            newBB->insertBack(newInst);
            newInst->setParent(newBB);
        }
        // if(isdebug) std::cout << "all inst copied." << std::endl;
        if(oldBB == func_inline->getEntry()) {
            entryBlock = newBB;
        }
    }

    // if(isdebug) std::cout << "func copied." << std::endl;

    //add pred and succ:
    for(auto it: basicBlockMap) {
        auto oldBB = it.first;
        auto newBB = it.second;
        for(auto bb = oldBB->pred_begin(); bb != oldBB->pred_end(); bb++) {
            newBB->addPred(basicBlockMap[*bb]);
        }
        for(auto bb = oldBB->succ_begin(); bb != oldBB->succ_end(); bb++) {
            newBB->addSucc(basicBlockMap[*bb]);
        }
    }

    //special inst:
    for(auto it: gepMap) {
        auto oldInst = it.first;
        auto newInst = it.second;
        auto oldInit = ((GepInstruction*)oldInst)->getInit();
        if (oldInit) {
            Operand* newInit;
            if (operandMap.count(oldInit))
                newInit = operandMap[oldInit];
            else {
                newInit = new Operand(new TemporarySymbolEntry(
                    oldInit->getType(), SymbolTable::getLabel()));
                operandMap[oldInit] = newInit;
            }
            ((GepInstruction*)newInst)->setInit1(newInit); //delete overload one.
        }
    }
    for(auto it: brMap) {
        auto oldInst = it.first;
        auto newInst = it.second;
        ((UncondBrInstruction*)newInst)->setBranch(
                basicBlockMap[((UncondBrInstruction*)oldInst)->getBranch()]);
    }
    for(auto it: cbrMap) {
        auto oldInst = it.first;
        auto newInst = it.second;
        auto oldUse = ((CondBrInstruction*)oldInst)->getUse()[0];
        Operand* newUse;
        if (operandMap.count(oldUse)) {
            newUse = operandMap[oldUse];
        } else {
            newUse = new Operand(new TemporarySymbolEntry(
                oldUse->getType(), SymbolTable::getLabel()));
            operandMap[oldUse] = newUse;
        }
        ((CondBrInstruction*)newInst)->replaceUse(oldUse, newUse);
        
        ((CondBrInstruction*)newInst)->setTrueBranch(
                basicBlockMap[((CondBrInstruction*)oldInst)->getTrueBranch()]);
        ((CondBrInstruction*)newInst)->setFalseBranch(
                basicBlockMap[((CondBrInstruction*)oldInst)->getFalseBranch()]);
    }

    //添加phi指令处理:
    for(auto it: phiMap) {
        auto oldInst = it.first;
        auto newInst = it.second;
        auto oldDef = ((PhiInstruction*)oldInst)->getDef();
        Operand* newDef;
        if (operandMap.count(oldDef))
            newDef = operandMap[oldDef];
        else {
            newDef = new Operand(new TemporarySymbolEntry(
                    oldDef->getType(), SymbolTable::getLabel()));
            operandMap[oldDef] = newDef;
        }
        newInst->replaceDef(newDef);

        ((PhiInstruction*)newInst)->getSrcs().clear();
        //((PhiInstruction*)newInst)->cleanUseInOperands();
        for (auto it : ((PhiInstruction*)oldInst)->getSrcs()) {
            auto oldSrc = it.second;
            Operand* newSrc;
            if (oldSrc->isConst()) {
                newSrc = oldSrc;
            } else {
                if (operandMap.count(oldSrc))
                    newSrc = operandMap[oldSrc];
                else {
                    newSrc = new Operand(new TemporarySymbolEntry(
                        oldSrc->getType(), SymbolTable::getLabel()));
                    operandMap[oldSrc] = newSrc;
                }
            }
            BasicBlock* newBB = basicBlockMap[it.first];
            ((PhiInstruction*)newInst)->addSrc(newBB, newSrc);
        }
    }
    
    for (auto bb: retBlocks) {
        bb->addSucc(exit_bb);
        exit_bb->addPred(bb);
    }
    //add br from call_bb to entry:
    new UncondBrInstruction(entryBlock, call_bb);
    call_bb->addSucc(entryBlock);
    entryBlock->addPred(call_bb);
    call_bb->remove(call); //remove call;

    //插入phi指令
    if(!ret2bb.empty()) {
        auto phi = new PhiInstruction(ret);
        ret->setOpdSe(ret->getSymbolEntry()); // for hoist
        phi->setIdentse((IdentifierSymbolEntry*)(ret->getSymbolEntry())); // for dce
        phi->push_back_opse(ret->getSymbolEntry()); // for cse
        for(auto it: ret2bb) {
            phi->addSrc(it.second, it.first);
        }
        exit_bb->insertFront(phi);
    }

    //manage ret:
    //改在ssaDes之后
    // if (ret) {
    //     Instruction* newInst;
    //     int size = retOperands.size();
    //     if (size > 1) {
    //         newInst = new PhiInstruction(ret);
    //         for (int i = 0; i < size; i++) {
    //             ((PhiInstruction*)newInst)->addSrc(retBlocks[i], retOperands[i]);
    //         }
    //     } else { //single pred, no phi;
    //         auto temp = new Operand(new ConstantSymbolEntry(ret->getType(), 0));
    //         newInst = new BinaryInstruction(BinaryInstruction::ADD, ret,
    //                                       retOperands[0], temp);
    //     }
    //     exit_bb->insertFront(newInst);
    //     newInst->setParent(exit_bb);
    // }

}

void FunctionInline::pass() {
    extractCaller();
    // if(isdebug) std::cout << "extract finished." << std::endl;
    
    for(auto it: caller) {
        cloneFunc(it.first);
    }

    // if(isdebug) std::cout << "func clone finished." << std::endl;

    for(auto func: this->callee) {
        unit->removeFunc(func);
        // if(isdebug) std::cout << "Func We ve Inlined: " << ((IdentifierSymbolEntry*)func->getSymPtr())->getName() << std::endl;
    }   
} 