#include "Vectorization.h"
#include "Instruction.h"
#include <unordered_set>
#include "Unit.h"
#define ITERBOUND 40

#define DEBUG_SWITCH_VEC 0
#if DEBUG_SWITCH_VEC
#define debugvec(str) std::cout << str << "\n";
#else
#define debugvec(str) //
#endif

bool asmChange = 0;

// #define DEBUG0429

void Vectorization::pass()
{
    detector = new LoopDetection(unit);
    detector->run();
    for (auto it = detector->begin(); it != detector->end(); it++) {

        auto oneloop = *it;
        BasicBlock* bodybb = *(oneloop->begin());
        // printf("oneloop body no = %d\n", bodybb->getNo());
        checkLoop(oneloop, (*(oneloop->begin()))->getParent());
    }
    // #ifdef DEBUG0429
    // std::cout<<"Vectorization::pass()\n";
    // #endif
    // std::vector<Function*> func_list = unit->get_functions();
    // #ifdef DEBUG0429
    // std::cout<<"func_list.size() = "<<func_list.size()<<"\n";
    // #endif
    // for(auto func = func_list.begin(); func != func_list.end(); func++){
    //     checkLoop(*func);
    // }
    // LoopDetection* loopdetection = new LoopDetection(unit);
    // getchar();
    // loopdetection->run();
    // // printf("before traverse loops\n");
    // // 获取所有的循环（嵌套的循环算一个？）
    // std::vector<blockSet*> innerLoops;
    // for(auto oneloop = loopdetection->begin(); oneloop != loopdetection->end(); oneloop ++)
    // {
    //     if(loopdetection->isBaseLoop(*oneloop))
    //     {
    //         innerLoops.push_back(*oneloop);
    //         BasicBlock* body_bb = *((*oneloop)->begin());
    //         printf("bodybb = %d\n", body_bb->getNo());
    //     }
    //     // printf("oneloop\n");
    //     // BasicBlock* cond_bb = loopdetection->getLoopEntry(*oneloop);
    //     // BasicBlock* body_bb = loopdetection->getLoopCond(*oneloop);
    //     // BasicBlock* end_bb = loopdetection->getLoopOut(*oneloop);
    //     // printf("cond_bb = %d\n", cond_bb->getNo());
    //     // printf("body_bb = %d\n", body_bb->getNo());
    //     // printf("end_bb = %d\n", end_bb->getNo());
    //     // printf("oneloop2\n");
    //     // getchar();
    // }
    // 如果bodybb的前驱块不是2个，返回
    // 如果有函数调用，不做
    // 如果bodybb里的phi指令不止一条，不做
}

// void Vectorization::checkLoop(Function* func)
// {
//     #ifdef DEBUG0429
//     std::cout<<"ConstantInfold::checkLoop()\n";
//     #endif
//     std::vector<loop_item*> loop_list = func->getLoopList();
//     std::vector<loop_item*> certificate_loops;
//     #ifdef DEBUG0429
//     std::cout<<"func->getLoopList().size = "<<func->getLoopList().size()<<"\n";
//     #endif
//     for(auto oneloop = loop_list.begin(); oneloop != loop_list.end(); oneloop ++)
//     {
//         loop_item* loopbbs = *oneloop;
//     #ifdef DEBUG0429
//         std::cout<<"cond_bb no = "<<loopbbs->cond_bb->getNo()<<"\n";
//         std::cout<<"while_bb no = "<<loopbbs->while_bb->getNo()<<"\n";
//         std::cout<<"end_bb no = "<<loopbbs->end_bb->getNo()<<"\n";
//     #endif
//         //if(!loopbbs.isBaseLoop())continue;
//         //if(loopbbs.getsize() != 2)continue;
//         //BasicBlock* body_bb = loopbbs->while_bb;//这里zkd代码是用一个循环找的，为什么？
//         if(loopbbs->while_bb->getSuccBlock().size() != 2)
//         {
//             continue;
//     #ifdef DEBUG0429
//             std::cout<<"loopbbs->while_bb->getSuccBlock().size() = "<<loopbbs->while_bb->getSuccBlock().size()<<"\n";
//             std::cout<<loopbbs->while_bb->getSuccBlock()[0]->getNo()<<"\n";
//             std::cout<<loopbbs->while_bb->getSuccBlock()[1]->getNo()<<"\n";
//             std::cout<<"loopbbs->while_bb->getSuccBlock().size() != 1 continue\n";
//     #endif
//         }
//         certificate_loops.push_back(loopbbs);
//     }
//     #ifdef DEBUG0429
//     std::cout<<"below transfer certificate_loops\n";
//     #endif
//     for(loop_item* oneloop : certificate_loops)
//     {
//     #ifdef DEBUG0429
//         std::cout<<"certificate_loop s onelooop\n";
//     #endif
//         //一个关于cond块的后继块是不是body块的测试
//         //检查body块中是否存在call指令
//         BasicBlock* body_bb = oneloop->while_bb;//这里zkd代码是用一个循环找的，为什么？
//         bool hasCall = false;
//         for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
//         {
//             if(dynamic_cast<CallInstruction*>(ins))hasCall = false;
            
//         }
//         if(hasCall)
//         {
//     #ifdef DEBUG0429_terminal
//             std::cout<<"hasCall continue\n";
//     #endif
//             continue;
//         }
//         int phiCount = 0;
//         BasicBlock* while_bb = oneloop->while_bb;
//         for(Instruction* ins = while_bb->begin(); ins != while_bb->end(); ins = ins->getNext())
//         {
//             if(ins->isPhi() == true)phiCount ++;
//         }
//         if(phiCount != 1)
//         {
//     #ifdef DEBUG0429_terminal
//             std::cout<<"phiCount = "<<phiCount<<"\n";
//             std::cout<<"phiCount != 1\n";
//     #endif
//             return;
//         }
//     #ifdef DEBUG0429
//         std::cout<<"call doVectorization\n";
//     #endif
//         doVectorization(oneloop, func);
//         // wzr: 目前先只做一个循环的向量化
//         return;
//     }
// }
void setOperandUse(BasicBlock* newbb)
{
    // printf("setOperandUse begin\n");
    for(Instruction* ins = newbb->begin(); ins != newbb->end(); ins = ins->getNext())
    {
        // printf("instname = %s, inst pointer = %d %d\n", ins->getInstName().c_str(), ins,ins->getOp().size());
        // printf("ins->getDef(): %s\n",ins->getDef()->toStr().c_str());
        for(int i = 0; i < ins->getOp().size(); i ++)
        {   
            if(ins->getOp()[i]==nullptr||ins->getOp()[i]->isConst()||ins->getOp()[i]->isGlobal())continue;
            // printf("  op: %s\n",ins->getOp()[i]->toStr().c_str());
            ins->getOp()[i]->addUse(ins);
            if(i == 0)ins->getOp()[i]->setDef(ins);
        }
        if(ins->isPhi())
        {
            // printf("ins is phi, dst = %s\n", ins->getOp()[0]->toStr().c_str());
            PhiInstruction* phi = dynamic_cast<PhiInstruction*>(ins);
            for(auto src : phi->getSrcs())
            {
                src.second->addUse(phi);
            }
        }
    }
    // printf("setOperandUse end\n");

    // for(Instruction* ins = newbb->begin(); ins != newbb->end(); ins = ins->getNext())
    // {
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         // ins->getOp()[i]->addUse(ins);
    //         // if(i == 0)ins->getOp()[i]->setDef(ins);
    //         // printf("op%s-->opptr = %d, use:\n", ins->getOp()[i]->toStr().c_str(), ins->getOp()[i]);
    //         for(auto ope : ins->getOp()[i]->getUse())
    //         {
    //             // printf("%d\t", ope);
    //         }
    //         // printf("\n");
    //         // printf("op%s-->opptr = %d, def:\n", ins->getOp()[i]->toStr().c_str(), ins->getOp()[i]);
    //         // printf("%d\n", ins->getOp()[i]->getDef());
    //     }
    //     // if(ins->isPhi())
    //     // {
    //     //     PhiInstruction* phi = dynamic_cast<PhiInstruction*>(ins);
    //     //     for(auto src : phi->getSrcs())
    //     //     {
    //     //         src.second->addUse(phi);
    //     //     }
    //     // }
    // }
}

void Vectorization::checkLoop(blockSet *oneloop, Function *func) {
    // printf("======checkLoop======= " << func->getSymPtr()->toStr()
    //                                 << " =============");

    // 一个关于cond块的后继块是不是body块的测试
    // 检查body块中是否存在call指令
    BasicBlock *body_bb =
        *(oneloop->begin()); // 这里zkd代码是用一个循环找的，为什么？
    if (body_bb->getSuccBlock().size() != 2) {

        return;
    }
    bool hasCall = false;
    for (Instruction *ins = body_bb->begin(); ins != body_bb->end();
         ins = ins->getNext()) {
        if (dynamic_cast<CallInstruction *>(ins))
            hasCall = false;
    }
    if (hasCall) {
        return;
    }
    int phiCount = 0;
    BasicBlock *while_bb = *(oneloop->begin());
    for (Instruction *ins = while_bb->begin(); ins != while_bb->end();
         ins = ins->getNext()) {
        if (ins->isPhi() == true)
            phiCount++;
    }
    // if (phiCount != 1) {
    //     return;
    // }
    doVectorization(oneloop, func);
}


// 以下是一些方便调试的工具函数
void display_instruction(Instruction* ins)
{
    printf("inst pointer = %d, inst type = %s\n", ins, ins->getInstName().c_str());
    for(int i = 0; i < ins->getOp().size(); i ++)
    {
        if(ins->getOp()[i]->isGlobal())
        {
            printf("op global = %s\n", ins->getOp()[i]->toStr().c_str());
            continue;
        }
        if(!ins->getOp()[i]->isConst())
            printf("op%d label = %d\n", i, ins->getOp()[i]->getLabel());
        else
            printf("op const value = %d\n", ins->getOp()[i]->getConstVal());
    }
    if(ins->isCond())
    {
        CondBrInstruction* cond = dynamic_cast<CondBrInstruction*>(ins);
        printf(", truebranch = %d, falsebranch = %d\n", cond->getTrueBranch()->getNo(), cond->getFalseBranch()->getNo());
    }
    else if(ins->isUncond())
    {
        UncondBrInstruction* uncond = dynamic_cast<UncondBrInstruction*>(ins);
        printf(", branch = %d\n", uncond->getBranch()->getNo());
    }
    else
    {
        printf("\n");
    }
    printf("display end\n");
}

void displayBB(BasicBlock* bb)
{
    printf("The BB No = %d\n", bb->getNo());
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        if(ins->isPhi()){
            display_instruction(ins);
            dynamic_cast<PhiInstruction*>(ins)->output_to_console();
        }
        else
        {
            display_instruction(ins);
        }
    }
    printf("The BB No = %d end\n", bb->getNo());
}

// 返回块中第一条具有指定类型的指令
Instruction* find_inst(int insttype, BasicBlock* bb)
{
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        if(ins->getInstType() == insttype)
        {
            return ins;
        }
    }
    // assert(0 && "cannot find inst of specific type in given bb");
    return nullptr;
}

std::vector<Instruction*> find_insts(int insttype, BasicBlock* bb)
{
    std::vector<Instruction*> resins;
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        if(ins->getInstType() == insttype)
        {
            resins.push_back(ins);
        }
    }
    // assert(0 && "cannot find inst of specific type in given bb");
    return resins;
}

bool find_bb(BasicBlock* bb, Function* func)
{
    std::vector<BasicBlock *> blocklist = func->getBlockList();
    for(int i = 0; i < blocklist.size(); i ++)
    {
        if(blocklist[i]->getNo() == bb->getNo())
        {
            return true;
        }
    }
    return false;
}

// 先找一条store指令，确定存入的值是0后，找到这个store对应的第一条gep指令（里面有数组首地址）
GepInstruction* find_gep(BasicBlock* body_bb)
{
    // printf("find_gep\n");
    for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    {
        if(ins->isStore())
        {
            // printf("ins->isStore()\n");
            StoreInstruction* store = dynamic_cast<StoreInstruction*>(ins);
            // display_instruction(store);
            // if(store->getOp()[1]->isConst())printf("store->getOp()[1]->isConst()\n");
            // printf("store->getOp()[1]->getConstVal() = %d\n", 
                // (int)(dynamic_cast<ConstantSymbolEntry*>(store->getOp()[1]->getSymbolEntry())->getValue()));
            if(store->getOp()[1]->isConst() && store->getOp()[1]->getConstVal() == 0)
            {
                // printf("in constval == 0\n");
                GepInstruction* gep3 = dynamic_cast<GepInstruction*>(store->getOp()[0]->getDef());
                // assert(gep3 != nullptr);
                if(gep3 == nullptr)return nullptr;
                // printf("in constval == 0  bp1\n");
                // display_instruction(gep3);
                GepInstruction* gep2 = dynamic_cast<GepInstruction*>(gep3->getOp()[1]->getDef());
                // assert(gep2 != nullptr);
                if(gep2 == nullptr)return nullptr;
                // display_instruction(gep2);
                GepInstruction* gep1 = dynamic_cast<GepInstruction*>(gep2->getOp()[1]->getDef());
                // assert(gep1 != nullptr);
                if(gep1 == nullptr)return nullptr;
                // display_instruction(gep1);
                return gep1;
            }
        }
    }
}

Instruction* get_lastInstruction(BasicBlock* bb)
{
    // printf("bb no = %d\n", bb->getNo());
    int i = 0;
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        // printf("instruction %d:\n", i);
        if(ins == nullptr)
        {
            continue;
        }
        else
        {
            // display_instruction(ins);
        }
        if(ins != nullptr && ins->getNext() == nullptr)
        {
            return ins;
        }
        i ++;
    }
}

void changeOperandLabel(BasicBlock* newbb, BasicBlock* oldbb)
{
    // printf("changeOperandLabel start\n");
    // 检查各operand在本块中的使用次数
    std::unordered_map<std::string, int> countop;
    for(Instruction* ins = newbb->begin(); ins != newbb->end(); ins = ins->getNext())
    {
        for(int i = 0; i < ins->getOp().size(); i++)
        {
            // printf("try to find op = %s, op can find? %d\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end());
            if(countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end())
            {
                int count = countop.find(ins->getOp()[i]->toStr().c_str())->second;
                countop.erase(ins->getOp()[i]->toStr().c_str());
                countop.insert(std::pair<std::string, int>(ins->getOp()[i]->toStr().c_str(), count + 1));
                // printf("countop insert pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), count + 1);
                // printf("countop insert2 pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str())->second);
            }
            else
            {
                countop.insert(std::pair<std::string, int>(ins->getOp()[i]->toStr().c_str(), 1));
                // printf("try to find op = %s, op can find? %d\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end());
                // // printf("op can find? %d\n", countop.find(ins->getOp()[i]) != countop.end());
                // printf("countop insert firsttime pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), 1);
                // printf("countop insert2 firsttime pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str())->second);
            }
        }
    }

    // printf("changeOperandLabel bp\n");
    std::unordered_map<std::string, Operand*> old2new;
    std::unordered_map<Operand*, Operand*> old2newop;
    Instruction* newins = newbb->begin();
    Instruction* oldins = oldbb->begin();
    for( ; newins != newbb->end() && oldins != oldbb->end(); 
        newins = newins->getNext(), oldins = oldins->getNext())
    {
        // printf("one ins name = %s\n", newins->getInstName().c_str());
        assert(newins->getOp().size() == oldins->getOp().size());
        if(newins->isPhi())
        {
            std::vector<Operand*> phioperands;
            phioperands.push_back(newins->getOp()[0]);
            for(auto src: dynamic_cast<PhiInstruction*>(newins)->getSrcs())
            {
                phioperands.push_back(src.second);
            }
            for(int i = 0; i < phioperands.size(); i ++)
            {
                // printf("op %d label = %s\n", i, phioperands[i]->toStr().c_str());
                // printf("countop count =  %d\n", countop.find(phioperands[i]->toStr().c_str())->second);
                // 如果这个临时变量的赋值是从其他块来的，不做处理
                // assert(oldins->getOp()[i]->getDef());
                // if(oldins->getOp()[i]->getDef()->getParent() != oldbb)continue;
                if(countop.find(phioperands[i]->toStr().c_str())->second == 1)continue;
                if(phioperands[i]->isGlobal() || phioperands[i]->isConst())continue;
                // printf("try to find label = %d\n", phioperands[i]->getLabel());
                if(old2new.find(phioperands[i]->toStr().c_str()) != old2new.end())
                {
                    // 说明这个operand已经被替换过了
                    // printf("in branch 1\n");
                    auto it = old2new.find(phioperands[i]->toStr().c_str());
                    // newins->setOperand(i, it->second);
                    if(i != 0)
                    {
                        dynamic_cast<PhiInstruction*>(newins)->changeSrcOperand(phioperands[i], it->second);
                    }
                }
                else if(phioperands[i]->getSymbolEntry()->isTemporary()
                    // || phioperands[i]->getSymbolEntry()->isVariable()
                    /*&& phioperands[i] == oldins->getOp()[i]*/)
                {
                    // printf("in branch 2\n");
                    Type* oldtype = oldins->getOp()[i]->getSymbolEntry()->getType();
                    Operand* newop = new Operand(new TemporarySymbolEntry(oldtype, SymbolTable::getLabel()));
                    // old2new.emplace(phioperands[i], newop);
                    old2new.insert(std::pair<std::string, Operand*>(phioperands[i]->toStr().c_str(), newop));
                    // printf("insert op label = {%d, %d}\n", phioperands[i]->getLabel(), newop->getLabel());
                    // printf("can map find it? %d\n", old2new.find(phioperands[i]) != old2new.end());
                    // newins->setOperand(i, newop);
                    if(i != 0)
                    {
                        dynamic_cast<PhiInstruction*>(newins)->changeSrcOperand(phioperands[i], newop);
                    }
                    // if(i == 0 && newins->isPhi())newins.setDst(newop);
                }
                else
                {
                    // printf("phioperands[i]->getSymbolEntry()->isConstant() = %d\n",phioperands[i]->getSymbolEntry()->isConstant());
                    // printf("phioperands[i]->getSymbolEntry()->isTemporary() = %d\n",phioperands[i]->getSymbolEntry()->isTemporary());
                    // printf("phioperands[i]->getSymbolEntry()->isVariable() = %d\n",phioperands[i]->getSymbolEntry()->isVariable());
                    // printf("in branch 3\n");
                }
            }
        }
        else{
            for(int i = 0; i < newins->getOp().size(); i ++)
            {
                // printf("op %d label = %s\n", i, newins->getOp()[i]->toStr().c_str());
                // printf("countop count =  %d\n", countop.find(newins->getOp()[i]->toStr().c_str())->second);
                // 如果这个临时变量的赋值是从其他块来的，不做处理
                // assert(oldins->getOp()[i]->getDef());
                // if(oldins->getOp()[i]->getDef()->getParent() != oldbb)continue;
                if(countop.find(newins->getOp()[i]->toStr().c_str())->second == 1)
                {
                    // 如果它只出现一次，一定是外部块为其赋过值的，应该用外部operand本身而不是copy时新new的operand
                    // wzr: 注意目前的copy函数虽然临时变量号没有改变，但operand指针其实是不同的
                    // 寄存器分配时认为它们是不同的
                    continue;
                }
                if(newins->getOp()[i]->isGlobal() || newins->getOp()[i]->isConst())continue;
                // printf("try to find label = %d\n", newins->getOp()[i]->getLabel());
                if(old2new.find(newins->getOp()[i]->toStr().c_str()) != old2new.end())
                {
                    // 说明这个operand已经被替换过了
                    // printf("in branch 1\n");
                    auto it = old2new.find(newins->getOp()[i]->toStr().c_str());
                    newins->setOperand(i, it->second);
                    if(i == 0)
                    {
                        // newins.getdef
                        it->second->setDef(newins);
                    }
                }
                else if(newins->getOp()[i]->getSymbolEntry()->isTemporary()
                    // || newins->getOp()[i]->getSymbolEntry()->isVariable()
                    /*&& newins->getOp()[i] == oldins->getOp()[i]*/)
                {
                    // printf("in branch 2\n");
                    Type* oldtype = oldins->getOp()[i]->getSymbolEntry()->getType();
                    Operand* newop = new Operand(new TemporarySymbolEntry(oldtype, SymbolTable::getLabel()));
                    // old2new.emplace(newins->getOp()[i], newop);
                    old2new.insert(std::pair<std::string, Operand*>(newins->getOp()[i]->toStr().c_str(), newop));
                    // printf("insert op label = {%d, %d}\n", newins->getOp()[i]->getLabel(), newop->getLabel());
                    // printf("can map find it? %d\n", old2new.find(newins->getOp()[i]) != old2new.end());
                    newins->setOperand(i, newop);
                    // if(i == 0 && newins->isPhi())newins.setDst(newop);
                }
                else
                {
                    // printf("newins->getOp()[i]->getSymbolEntry()->isConstant() = %d\n",newins->getOp()[i]->getSymbolEntry()->isConstant());
                    // printf("newins->getOp()[i]->getSymbolEntry()->isTemporary() = %d\n",newins->getOp()[i]->getSymbolEntry()->isTemporary());
                    // printf("newins->getOp()[i]->getSymbolEntry()->isVariable() = %d\n",newins->getOp()[i]->getSymbolEntry()->isVariable());
                    // printf("in branch 3\n");
                }
            }

        }
    }
    // printf("changeOperandLabel end\n");
}

void changeOperandLabel2(BasicBlock* newbb, BasicBlock* oldbb)
{
    // printf("changeOperandLabel2 start\n");
    // 检查各operand在本块中的使用次数
    std::unordered_map<std::string, int> countop;
    for(Instruction* ins = newbb->begin(); ins != newbb->end(); ins = ins->getNext())
    {
        for(int i = 0; i < ins->getOp().size(); i++)
        {
            // printf("try to find op = %s, op can find? %d\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end());
            if(countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end())
            {
                int count = countop.find(ins->getOp()[i]->toStr().c_str())->second;
                countop.erase(ins->getOp()[i]->toStr().c_str());
                countop.insert(std::pair<std::string, int>(ins->getOp()[i]->toStr().c_str(), count + 1));
                // printf("countop insert pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), count + 1);
                // printf("countop insert2 pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str())->second);
            }
            else
            {
                countop.insert(std::pair<std::string, int>(ins->getOp()[i]->toStr().c_str(), 1));
                // printf("try to find op = %s, op can find? %d\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str()) != countop.end());
                // // printf("op can find? %d\n", countop.find(ins->getOp()[i]) != countop.end());
                // printf("countop insert firsttime pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), 1);
                // printf("countop insert2 firsttime pair {operand = %s, count = %d}\n", ins->getOp()[i]->toStr().c_str(), countop.find(ins->getOp()[i]->toStr().c_str())->second);
            }
        }
    }

    // printf("changeOperandLabel2 bp\n");
    std::unordered_map<std::string, Operand*> old2new;
    std::unordered_map<Operand*, Operand*> old2newop;
    Instruction* newins = newbb->begin();
    Instruction* oldins = oldbb->begin();
    // for( ; newins != newbb->end(); newins = newins->getNext())
    for( ; newins != newbb->end() && oldins != oldbb->end(); 
        newins = newins->getNext(), oldins = oldins->getNext())
    {
        // printf("one ins name = %s\n", newins->getInstName().c_str());
        // assert(newins->getOp().size() == oldins->getOp().size());
        if(newins->isPhi())
        {
            std::vector<Operand*> phioperands;
            phioperands.push_back(newins->getOp()[0]);
            for(auto src: dynamic_cast<PhiInstruction*>(newins)->getSrcs())
            {
                phioperands.push_back(src.second);
            }
            for(int i = 0; i < phioperands.size(); i ++)
            {
                // printf("op %d label = %s\n", i, phioperands[i]->toStr().c_str());
                // printf("countop count =  %d\n", countop.find(phioperands[i]->toStr().c_str())->second);
                // 如果这个临时变量的赋值是从其他块来的，不做处理
                // assert(oldins->getOp()[i]->getDef());
                // if(oldins->getOp()[i]->getDef()->getParent() != oldbb)continue;
                if(countop.find(phioperands[i]->toStr().c_str())->second == 1)
                {
                    // printf("second == 1\n");
                    // printf("second == 1:%s\n", phioperands[i]->toStr().c_str());
                    // 拷贝原有的def use关系
                    assert(oldins->getOp()[i]);
                    for(auto use : oldins->getOp()[i]->getUse())
                    {
                        phioperands[i]->addUse(use);
                    }
                    phioperands[i]->setDef(oldins->getOp()[i]->getDef());
                }
                if(phioperands[i]->isGlobal() || phioperands[i]->isConst())continue;
                // printf("try to find label = %d\n", phioperands[i]->getLabel());
                if(old2new.find(phioperands[i]->toStr().c_str()) != old2new.end())
                {
                    // 说明这个operand已经被new过了
                    // printf("in branch 1\n");
                    auto it = old2new.find(phioperands[i]->toStr().c_str());
                    // newins->setOperand(i, it->second);
                    if(i != 0)
                    {
                        dynamic_cast<PhiInstruction*>(newins)->changeSrcOperand(phioperands[i], it->second);
                    }
                }
                else if(phioperands[i]->getSymbolEntry()->isTemporary()
                    // || phioperands[i]->getSymbolEntry()->isVariable()
                    /*&& phioperands[i] == oldins->getOp()[i]*/)
                {
                    // printf("in branch 2\n");
                    // Type* oldtype = oldins->getOp()[i]->getSymbolEntry()->getType();
                    // Operand* newop = new Operand(new TemporarySymbolEntry(oldtype, SymbolTable::getLabel()));
                    // // old2new.emplace(phioperands[i], newop);
                    old2new.insert(std::pair<std::string, Operand*>(phioperands[i]->toStr().c_str(), newins->getOp()[i]));
                    // printf("insert op label = {%d, %d}\n", phioperands[i]->getLabel(), newop->getLabel());
                    // // printf("can map find it? %d\n", old2new.find(phioperands[i]) != old2new.end());
                    // // newins->setOperand(i, newop);
                    // if(i != 0)
                    // {
                    //     dynamic_cast<PhiInstruction*>(newins)->changeSrcOperand(phioperands[i], newop);
                    // }
                    // if(i == 0 && newins->isPhi())newins.setDst(newop);
                }
                else
                {
                    // printf("phioperands[i]->getSymbolEntry()->isConstant() = %d\n",phioperands[i]->getSymbolEntry()->isConstant());
                    // printf("phioperands[i]->getSymbolEntry()->isTemporary() = %d\n",phioperands[i]->getSymbolEntry()->isTemporary());
                    // printf("phioperands[i]->getSymbolEntry()->isVariable() = %d\n",phioperands[i]->getSymbolEntry()->isVariable());
                    // printf("in branch 3\n");
                }
            }
        }
        else{
            for(int i = 0; i < newins->getOp().size(); i ++)
            {
                // printf("op %d label = %s\n", i, newins->getOp()[i]->toStr().c_str());
                // printf("countop count =  %d\n", countop.find(newins->getOp()[i]->toStr().c_str())->second);
                // 如果这个临时变量的赋值是从其他块来的，不做处理
                // assert(oldins->getOp()[i]->getDef());
                // if(oldins->getOp()[i]->getDef()->getParent() != oldbb)continue;
                if(countop.find(newins->getOp()[i]->toStr().c_str())->second == 1)
                {
                    // 如果它只出现一次，一定是外部块为其赋过值的，应该用外部operand本身而不是copy时新new的operand
                    // wzr: 注意目前的copy函数虽然临时变量号没有改变，但operand指针其实是不同的
                    // 寄存器分配时认为它们是不同的
                    // printf("second == 1\n");
                    // printf("second == 1:%s\n", newins->getOp()[i]->toStr().c_str());
                    // 拷贝原有的def use关系
                    assert(oldins->getOp()[i]);
                    for(auto use : oldins->getOp()[i]->getUse())
                    {
                        newins->getOp()[i]->addUse(use);
                    }
                    newins->getOp()[i]->setDef(oldins->getOp()[i]->getDef());
                    continue;
                }
                if(newins->getOp()[i]->isGlobal() || newins->getOp()[i]->isConst())continue;
                // printf("try to find label = %d\n", newins->getOp()[i]->getLabel());
                if(old2new.find(newins->getOp()[i]->toStr().c_str()) != old2new.end())
                {
                    // 说明这个operand已经被new过了
                    // printf("in branch 1\n");
                    auto it = old2new.find(newins->getOp()[i]->toStr().c_str());
                    newins->setOperand(i, it->second);
                    if(i == 0)
                    {
                        // newins.getdef
                        it->second->setDef(newins);
                        // wzr: 
                        // it->second->addUse(newins);
                    }
                }
                else if(newins->getOp()[i]->getSymbolEntry()->isTemporary()
                    // || newins->getOp()[i]->getSymbolEntry()->isVariable()
                    /*&& newins->getOp()[i] == oldins->getOp()[i]*/)
                {
                    // printf("in branch 2\n");
                    // Type* oldtype = oldins->getOp()[i]->getSymbolEntry()->getType();
                    // Operand* newop = new Operand(new TemporarySymbolEntry(oldtype, SymbolTable::getLabel()));
                    // // old2new.emplace(newins->getOp()[i], newop);
                    old2new.insert(std::pair<std::string, Operand*>(newins->getOp()[i]->toStr().c_str(), newins->getOp()[i]));
                    // printf("insert op label = {%d, %d}\n", newins->getOp()[i]->getLabel(), newop->getLabel());
                    // // printf("can map find it? %d\n", old2new.find(newins->getOp()[i]) != old2new.end());
                    // newins->setOperand(i, newop);
                    // if(i == 0 && newins->isPhi())newins.setDst(newop);
                    continue;
                }
                else
                {
                    // printf("newins->getOp()[i]->getSymbolEntry()->isConstant() = %d\n",newins->getOp()[i]->getSymbolEntry()->isConstant());
                    // printf("newins->getOp()[i]->getSymbolEntry()->isTemporary() = %d\n",newins->getOp()[i]->getSymbolEntry()->isTemporary());
                    // printf("newins->getOp()[i]->getSymbolEntry()->isVariable() = %d\n",newins->getOp()[i]->getSymbolEntry()->isVariable());
                    // printf("in branch 3\n");
                }
            }

        }
    }
    // printf("changeOperandLabel2 end\n");
}

bool checkMemset(blockSet* oneloop, Function* func, LoopDetection* detector)
{
    // getchar();
    BasicBlock *body_bb = *(oneloop->begin());
    BasicBlock *cond_bb = detector->getCondbb(body_bb);
    BasicBlock *end_bb = detector->getEndbb(body_bb);
    std::vector<unsigned int> mylist;
    bool st = false;
    for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    {
        if(ins->isGep())st = true;
        if(st)
        {
            mylist.push_back(ins->getInstType());
        }
        // if()
    }
    // getchar();
    if(mylist.size() <= 7)return false;
    if(mylist[0] == Instruction::GEP
        && mylist[1] == Instruction::GEP
        && mylist[2] == Instruction::GEP
        && mylist[3] == Instruction::STORE
        && mylist[4] == Instruction::GEP
        && mylist[5] == Instruction::GEP
        && mylist[6] == Instruction::GEP
        && mylist[7] == Instruction::STORE)
    {
        return true;
    }
    // getchar();
    return false;
}

void doMemset(BasicBlock* body_bb, Function* func, Unit* myunit)
{
    printf("doMemset modified code!\n");
    // getchar();
    // 1: 添一个块做memset
    BasicBlock* memsetbb = new BasicBlock(func);
    // 1-1: 新建call指令
    // std::string name = "llvm.memset.p0.i32";
    std::string name = "memset";
    SymbolEntry *funcSE;
    auto int8PtrType = new PointerType(TypeSystem::int8Type);
    // Operand *int8Ptr = new Operand(new TemporarySymbolEntry(
    //                 int8PtrType, SymbolTable::getLabel()));
    // BitcastInstruction *bitcast =
    //     new BitcastInstruction(int8Ptr, addr, bb);
    // bitcast->push_back_opse(se);
    if (identifiers->lookup(name) == nullptr) {
        std::vector<Type *> vec;
        vec.push_back(int8PtrType);
        vec.push_back(TypeSystem::int8Type);
        vec.push_back(TypeSystem::intType);
        vec.push_back(TypeSystem::boolType);
        std::vector<SymbolEntry *> vec1;
        auto funcType =
            new FunctionType(TypeSystem::voidType, vec, vec1);
        SymbolTable *st = identifiers;
        while (st->getPrev())
            st = st->getPrev();
        funcSE = new IdentifierSymbolEntry(funcType, name,
                                            st->getLevel());
        st->install(name, funcSE);
        myunit->insertDeclare(funcSE);
    } else {
        funcSE = identifiers->lookup(name);
        assert(funcSE);
    }
    std::vector<Operand *> params;
    GepInstruction* gep = find_gep(body_bb);
    if(gep == nullptr)return;
    // printf("gep != nullptr\n");
    GepInstruction* gep1 = gep;
    // display_instruction(gep1);
    GepInstruction* gep2 = dynamic_cast<GepInstruction*>(gep1->getNext());
    // display_instruction(gep2);
    GepInstruction* gep3 = dynamic_cast<GepInstruction*>(gep2->getNext());
    // display_instruction(gep3);
    Instruction* store = gep3->getNext();
    Operand* arr = gep->getOp()[1];
    Operand* arr_gepdst = new Operand(new TemporarySymbolEntry((TypeSystem::intType), SymbolTable::getLabel()));
    if(arr->isGlobal())
    {
        // printf("new gep\n");
        GepInstruction* newgep1 = dynamic_cast<GepInstruction*>(gep1->copy(gep1, memsetbb));
        // GepInstruction* newgep2 = dynamic_cast<GepInstruction*>(gep2->copy(gep2, memsetbb));
        // GepInstruction* newgep3 = dynamic_cast<GepInstruction*>(gep3->copy(gep3, memsetbb));
        newgep1->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)));
        // newgep2->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)));
        // newgep3->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)));
        // newgep3->setOperand(0, arr_gepdst);
        newgep1->setOperand(0, arr_gepdst);
        // memsetbb->insertFront(gep1);
        // memsetbb->insertFront(gep2);
        // memsetbb->insertFront(gep3);
        // printf("new gep end\n");
        // new GepInstruction(arr_gepdst, arr, 
        //     new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)), memsetbb);
        // new LoadInstruction(arr_gepdst, arr, memsetbb);
        // new BinaryInstruction(BinaryInstruction::ADD, arr_gepdst, arr, 
        //     new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)), memsetbb);
    }
    // printf("arr type = %s\n", arr->getType()->toStr().c_str());
    Operand* arr_dst = new Operand(new TemporarySymbolEntry(new PointerType(TypeSystem::int8Type), SymbolTable::getLabel()));
    // BitcastInstruction* bitcast = new BitcastInstruction(
    //         arr_dst, arr_gepdst, memsetbb);
    // arr是一个global数组, 不能用getLabel()来展示
    // printf("arr label = %s\n", arr->toStr().c_str());
    // 参数0：数组
    params.push_back(arr_gepdst);
    // 参数1：0
    params.push_back(new Operand(
        new ConstantSymbolEntry(TypeSystem::int8Type, 0)));
    SymbolEntry* arr_se = arr->getSymbolEntry();
    assert(arr_se != nullptr);
    // printf("arr_se type = %s, isarr()?%d\n", arr_se->getType()->toStr().c_str(), arr_se->getType()->isArray());
    int size = (int)(dynamic_cast<ArrayType*>(
        dynamic_cast<PointerType*>(arr_se->getType())->getType()
    )->getLength());
    // printf("size = %d\n", size);
    int size3 = size * size * size;
    // std::cout<<"size = "<<size <<"\n";
    // 参数2：内存大小
    params.push_back(new Operand(
        new ConstantSymbolEntry(TypeSystem::intType, size3 * 4)));
    // params.push_back(new Operand(
    //     new ConstantSymbolEntry(TypeSystem::boolType, 0)));
    new CallInstruction(nullptr, funcSE, params, memsetbb);
    // 1-2: 新建跳转指令
    BasicBlock* while3_pred = func->getEntry();
    BasicBlock* while3 = while3_pred->getSuccBlock()[0];
    UncondBrInstruction* uncond = new UncondBrInstruction(while3, memsetbb);
    // 1-3: 维护跳转指令
    CallInstruction* call_getint1 = dynamic_cast<CallInstruction*>(find_inst(Instruction::CALL, while3_pred));
    Operand* getNdst = call_getint1->getOp()[0];
    printf("getNdst label = %d\n", getNdst->getLabel());
    // UncondBrInstruction* uncond2 = dynamic_cast<UncondBrInstruction*>(
    //         find_inst(Instruction::UNCOND, while3_pred));
    // Instruction* br = while3_pred->end();
    // Instruction* br = get_lastInstruction(while3_pred);
    Instruction* br = find_inst(Instruction::UNCOND, while3_pred);
    if(dynamic_cast<UncondBrInstruction*>(br) == nullptr)
    {
        br = find_inst(Instruction::COND, while3_pred);
        if(dynamic_cast<CondBrInstruction*>(br) == nullptr)
        {
            assert(0 && "while3_bb doesn't have condbr or uncondbr");
        }
    }
    // printf("after get last instruction\n");
    assert(br != nullptr);
    Operand* cmp_dst = new Operand(new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel()));
    CmpInstruction* cmp = new CmpInstruction(CmpInstruction::L, cmp_dst, getNdst, 
        new Operand(new ConstantSymbolEntry(TypeSystem::intType, size)), nullptr);
    while3_pred->insertBefore(cmp, br);
    // printf("bp 1\n");
    BasicBlock* origin_succ = nullptr;
    // printf("br instname = %s\n", br->getInstName().c_str());
    // printf("br = %d\n", br);
    if(br->isUncond())origin_succ = dynamic_cast<UncondBrInstruction*>(br)->getBranch();
    else if(br->isCond())origin_succ = dynamic_cast<CondBrInstruction*>(br)->getTrueBranch();
    // printf("origin_succ = %d\n", origin_succ->getNo());
    CondBrInstruction* condbr = new CondBrInstruction(origin_succ, memsetbb, cmp_dst);
    while3_pred->insertBefore(condbr, br);
    // printf("br = %d\n", br);

    // return;
    while3_pred->remove(br);
    // uncond2->setBranch(memsetbb);
    // 1-3: 维护块前驱、后继关系
    // while3_pred --> memsetbb
    // while3_pred->removeSucc(while3);
    while3_pred->addSucc(memsetbb);
    memsetbb->addPred(while3_pred);
    // memsetbb --> while3_cond
    memsetbb->addSucc(while3);
    // while3->removePred(while3_pred);
    while3->addPred(memsetbb);

    // 删掉原循环中的第二组store
    
    body_bb->remove(gep1);
    body_bb->remove(gep2);
    body_bb->remove(gep3);
    body_bb->remove(store);

    printf("memset end\n");
}

void setBranch_trueBranch(BasicBlock* branch_truebranch, BasicBlock* bb_toprocess)
{
    // printf("setbranch start\n");
    // printf("bb_toprocess = =%d\n", bb_toprocess->getNo());
    Instruction* br = find_inst(Instruction::UNCOND, bb_toprocess);
    UncondBrInstruction* uncond = nullptr;
    CondBrInstruction* cond = nullptr;
    if(dynamic_cast<UncondBrInstruction*>(br) == nullptr)
    {
        cond = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, bb_toprocess));
        // printf("cond, true branch from %d to %d\n", cond->getTrueBranch(), branch_truebranch);
        cond->setTrueBranch(branch_truebranch);
    }
    else
    {
        uncond = dynamic_cast<UncondBrInstruction*>(br);
        // printf("uncond, branch from %d to %d\n", uncond->getBranch(), branch_truebranch);
        uncond->setBranch(branch_truebranch);
    }
    // printf("setbranch end\n");
}

// printf("is sitofp = %d\n", ins->isSitofp());
void Vectorization::doVectorization(blockSet *oneloop, Function *func)
{
    // std::cout<<"in doVectorization func first line\n";
    // BasicBlock* cond_bb = oneloop->cond_bb;
    // BasicBlock* body_bb = oneloop->while_bb;
    // BasicBlock* end_bb = oneloop->end_bb;

    BasicBlock *body_bb = *(oneloop->begin());
    BasicBlock *cond_bb = detector->getCondbb(body_bb);
    BasicBlock *end_bb = detector->getEndbb(body_bb);

    int vectorization_type = 0; // 0 --> no vectorization, 1 --> dst[i] = 0, 2 --> dst[i] = src[i]

    // if(this->condbb != nullptr)return;
    this->condbb = cond_bb;
    this->bodybb = body_bb;
    this->endbb = end_bb;

    // printf("cond_bb = %d\n", cond_bb->getNo());
    // printf("body_bb = %d\n", body_bb->getNo());
    // printf("end_bb = %d\n", end_bb->getNo());
    debugvec("cond_bb = " << cond_bb->getNo());
    debugvec("body_bb = " << body_bb->getNo());
    debugvec("end_bb = " << end_bb->getNo());

    // 如果有函数调用，直接拒绝
    if(find_inst(Instruction::CALL, cond_bb) != nullptr)return;
    if(find_inst(Instruction::CALL, body_bb) != nullptr)return;
    if(find_inst(Instruction::CALL, end_bb) != nullptr)return;

    // 如果当前块已经在函数中被删除，说明该循环已经被循环展开了，拒绝
    if(find_bb(cond_bb, func) == false)return;
    if(find_bb(body_bb, func) == false)return;
    // 一般来说end_bb是不会被删除的
    // getchar();
    debugvec("1\n");

    if(find_inst(Instruction::CMP, body_bb) == nullptr)
    {
        // 循环体的body块中没有cmp指令，很可能已经做过循环展开
        // 目前不再对这种情况进行向量化，就算做向量化，也另写一段操作
        return;
    }

    // return;
    // 为后面补全循环次数做准备
    // BasicBlock* condbb_copy = cond_bb->copybb(func);
    // BasicBlock* bodybb_copy = body_bb->copybb(func);
    // BasicBlock* endbb_copy = new BasicBlock(func);
    // BasicBlock* endbb_copy = end_bb->copybb(func);
    // wzr: 这里可能出问题，比如说bodybb的最后一条指令发现不是cond类型

    // printf("iscond? %d\n", find_inst(Instruction::COND, body_bb)->isCond());
    // displayBB(body_bb);
    // printf("mycond?\n");
    // display_instruction(find_inst(Instruction::COND, body_bb));
    // BasicBlock* tempbb1, *tempbb2;
    // BasicBlock* tempbb1 = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, body_bb))->getTrueBranch()->copybb(func);
    // BasicBlock* tempbb1 = new BasicBlock(func);
    // BasicBlock* tempbb2 = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, body_bb))->getFalseBranch()->copybb(func);
    // getchar();
    debugvec("2\n");

    // return;
    int start, end;
    Operand* newend;
    Instruction* br = (body_bb->getBrorRet());
    Instruction* phi = body_bb->begin();
    //std::cout<<"before assert cond bb dose not start with phi\n";
    if(!phi->isPhi())return;
    // assert(phi->isPhi() && "cond bb dose not start with phi");
    // auto operands = (dynamic_cast<PhiInstruction*>(phi))->getPhiOperands();
    // auto bbs = (dynamic_cast<PhiInstruction*>(phi))->getPhiBBs();
    if(dynamic_cast<PhiInstruction*>(phi)->getSrcs().size() != 2)
    {
        return;
    }
    // dynamic_cast<PhiInstruction*>(phi)->output_to_console();
    Operand* phi_src0_second = dynamic_cast<PhiInstruction*>(phi)->getSrcs().begin()->second;
    // printf("operands[0], bb = %d\n", dynamic_cast<PhiInstruction*>(phi)->getSrcs().begin()->first->getNo());
    // printf("operands[0] = %s\n", dynamic_cast<PhiInstruction*>(phi)->getSrcs().begin()->second->toStr().c_str());
    if(!phi_src0_second->isConst())
    {
        return;
    }
    // getchar();
    debugvec("3\n");
    // dynamic_cast<PhiInstruction*>(phi)->output_to_console();
    // printf("bbs[0] No = %d\n", bbs[0]->getNo());
    // printf("bbs[1] No = %d\n", bbs[1]->getNo());
    // printf("body_bb No = %d\n", body_bb->getNo());
    
    bool find_loopbb_in_phi = 1;
    for(auto src: dynamic_cast<PhiInstruction*>(phi)->getSrcs()){
        if(src.first->getNo()==body_bb->getNo()){
            find_loopbb_in_phi = 1;
        }
    }
    // assert((bbs[0]->getNo() == body_bb->getNo() || bbs[1]->getNo() == body_bb->getNo()) && "Inheriant const from loop by phi");
    assert(find_loopbb_in_phi && "Inheriant const from loop by phi");
    
    start = phi_src0_second->getConstVal();
    // std::cout<<"start1 = "<<start<<"\n";
    (dynamic_cast<PhiInstruction*>(phi)->getSrcs().end())->second;
    // Instruction* iter = operands[1]->getDef();
    // Instruction* iter = (dynamic_cast<PhiInstruction*>(phi)->getSrcs().end())->second->getDef();
    Instruction* cmp_inbody = find_inst(Instruction::CMP, body_bb);
    Instruction* iter = cmp_inbody->getOp()[1]->getDef();
    Operand* myop = dynamic_cast<CondBrInstruction*>(br)->getCond();
    assert(myop != nullptr && "myop == nullptr");
    Instruction* comparer = myop->getDef();
    //std::vector<Operand*> ops = br->getOp();
    assert(comparer != nullptr && "br->getOp() == nullptr");
    if(!comparer->isCmp())
    {
        return;
    }
    // return;
    // getchar();
    debugvec("4\n");
    // 原本的常量循环展开非常量不展，但现在向量化变量也是可以做的
    // if(!comparer->getOp()[2]->isConst())
    // {
    //     return;
    // }
    // end = comparer->getOp()[2]->getConstVal();
    newend = comparer->getOp()[2];

    // // may cause problem!!
    Operand* op1 = comparer->getOp()[1];
    Operand* op2 = op1->getDef()->getOp()[1];

    #ifdef DEBUG0429
    #endif
    // std::cout<<"stage2\n";
    // return;
    int iterPattern = -1;
    int accumulator;
    // printf("iter = %d\n", iter);
    // display_instruction(iter);
    // printf("iter op size = %d\n", iter->getOp().size());
    if(iter->getOp().size() != 3 || 
        !iter->getOp()[2]->isConst())
    {
        return;
    }
    // getchar();
    debugvec("5\n");
    // printf("iter inst = %s, dst = ");
    // display_instruction(iter);
    accumulator = iter->getOp()[2]->getConstVal();
    #ifdef DEBUG0429
    std::cout<<"accumulator = "<<accumulator<<"\n";
    #endif
    // 此处要做向量化，accumulator应该从1变成4
    // wzr: 如果accumulator不是1，不做，因为内存地址不连续的先不考虑
    if(accumulator != 1)
    {
        return;
    }
    // // 给他设置为4(这里太早了，后面设置)
    // iter->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));

    if(iter->isBin() && iter->getOpcode() == BinaryInstruction::ADD)
    {
        iterPattern = 0;
    }
    else if(iter->isBin() && iter->getOpcode() == BinaryInstruction::SUB)
    {
        // wzr: 减法的也先不管
        return;
        // iterPattern = 1;
        // accumulator = -accumulator;
    }
    else{
        return;
    }
    // 向量化的话，是不能要求算得出iternum的
    // int iternum = (end - start) / accumulator;
    // iternum = abs(iternum);
    // //std::cout<<"iternum  = "<<iternum<<"\n";
    // if(iternum > ITERBOUND)
    // {
    //     #ifdef DEBUG0429_terminal
    //         std::cout<<"(end - start) / accumulator > ITERBOUND\n";
    //     #endif
    //     return;
    // }
    // 向量化中没有这种可能
    // if(iterPattern == -1)
    // {
    //     #ifdef DEBUG0429_terminal
    //         std::cout<<"iterPattern == -1\n";
    //     #endif
    //     return;
    // }
    // return;
    if(comparer->getOpcode() != CmpInstruction::L)
    {
        #ifdef DEBUG0429_terminal
            std::cout<<"comparer->getOpcode() != CmpInstruction::L\n";
        #endif
        return;
    }
    #ifdef DEBUG0429
    #endif
    
    // std::cout<<"stage3\n";
    std::unordered_set<Instruction*> ignored_ins{phi, comparer, br};
    #ifdef DEBUG0429
    std::cout<<"ignored: phi = "<<phi<<" comparer = "<<comparer<<" br = "<<br<<"\n";
    #endif
    // BasicBlock* outBB = oneloop->end_bb;
    // for(auto BB : cond_bb->getSuccBlock())
    // {
    //     if(BB != body_bb)outBB = BB;
    // }
    #ifdef DEBUG0429
    // std::cout<<"outBB.no = "<<outBB->getNo()<<"\n";
    #endif

    auto block_list0 = func->getBlockList();

    // BasicBlock* new_bb = new BasicBlock(func);
    //std::cout<<"new_bb No = "<<new_bb->getNo()<<"\n";
    std::unordered_map<Instruction*, Instruction*> old2new;
    #ifdef DEBUG0429
    std::cout<<"start = "<<start<<" end = "<<end<<"\n";
    #endif
    // getchar();
    debugvec("6\n");
    //std::cout<<"doVectorization begin\n";
    std::vector<Function*> func_list = unit->get_functions();

    // printf("cond_bb = %d\n", cond_bb->getNo());
    // printf("body_bb = %d\n", body_bb->getNo());
    // printf("end_bb = %d\n", end_bb->getNo());
    // getchar();
    if(checkMemset(oneloop, func, detector))doMemset(body_bb, func, unit);
    
    // return;

    // // 设置循环次数是否为4的整倍数的判断逻辑
    // BasicBlock* bodybb_novec = body_bb->copybb(func);
    // display_instruction(cmp_inbody);
    // Operand* iter_num = cmp_inbody->getOp()[2];
    // // printf("iter_num label = %d\n", iter_num->getLabel());
    // getchar();

    // BasicBlock* judgevec = new BasicBlock(func);
    // Operand* mod_dst = new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel()));
    // BinaryInstruction* mod = new BinaryInstruction(BinaryInstruction::MOD, mod_dst, iter_num, 
    //     new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)), judgevec);
    // Operand* cmp_dst = new Operand(new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel()));
    // CmpInstruction* cmp_injudge = new CmpInstruction(CmpInstruction::E, cmp_dst, mod_dst, 
    //     new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)), judgevec);
    // CondBrInstruction* condbr_injudge = new CondBrInstruction(body_bb, bodybb_novec, cmp_dst, judgevec);

    // // 处理这段逻辑的前驱、后继关系
    // // cond_bb --> judgevec
    // BasicBlock* body_pred = nullptr;// 如果有多个，就会出问题
    // for(BasicBlock* pred : body_bb->getPredBlock())
    // {
    //     if(pred != body_bb)
    //     {
    //         pred->removeSucc(body_bb);
    //         pred->addSucc(judgevec);
    //         judgevec->addPred(pred);
    //         // body_bb->removeSucc(pred);
    //         body_pred = pred;
    //     }
    // }
    // // body_pred = cond_bb;
    // assert(body_pred != nullptr);
    // printf("body_pred no = %d\n", body_pred->getNo());
    // // return;
    // // judgevec --> body_bb, bodybb_novec
    // judgevec->addSucc(body_bb);
    // body_bb->addPred(judgevec);
    // judgevec->addSucc(bodybb_novec);
    // bodybb_novec->addPred(judgevec);

    // // 整理phi指令
    // // UncondBrInstruction* uncond = find_inst(Instruction::UNCOND, cond_bb);
    // setBranch_trueBranch(judgevec, body_pred);
    // // setBranch_trueBranch(bodybb_novec, bodybb_novec);
    // PhiInstruction* phi_inbody = dynamic_cast<PhiInstruction*>(body_bb->begin());
    // assert(phi_inbody);
    // for(BasicBlock* bb : phi_inbody->getPhiBBs())
    // {
    //     if(bb == body_pred)
    //     {
    //         bb = judgevec;
    //     }
    // }
    // return;
    // PhiInstruction* phi_inbody_nov = dynamic_cast<PhiInstruction*>(bodybb_novec->begin());
    // assert(phi_inbody_nov);
    // for(BasicBlock* bb : phi_inbody_nov->getPhiBBs())
    // {
    //     if(bb == body_pred)
    //     {
    //         bb = judgevec;
    //     }
    // }

    // // return;
    // getchar();
    debugvec("7\n");

    BasicBlock* bodybb_novec = body_bb->copybb(func);
    // displayBB(bodybb_novec);
    // getchar();
    changeOperandLabel2(bodybb_novec, body_bb);
    setOperandUse(bodybb_novec);
    // return;
    // BasicBlock* bodybb_novec = nullptr;
    bool vectorization_stage1 = true;
    bool vectorization_stage2 = true;
    if(find_insts(Instruction::STORE, body_bb).size() > 1)return;
    for(Instruction* ins = bodybb->begin(); ins != bodybb->end(); ins = ins->getNext())
    {
        if(ins->isGep() && !ins->getNext()->isGep())
        {
            if(!ins->getNext()->isStore())
            {
                // printf("the instruction next to gep is not store?\n");
                // return;
                vectorization_stage1 = false;
                break;
            }
            StoreInstruction* store = dynamic_cast<StoreInstruction*>(ins->getNext());
            // 下面这句assert(0)本意是好的，但是store的op1是指针类型，这种写法并不能正确比较两个label
            // printf("store op1 = %d, gep op0 = %d\n", store->getOp()[1]->getLabel(), ins->getOp()[0]->getLabel());
            // if(store->getOp()[1]->getLabel() != ins->getOp()[0]->getLabel())assert(0 && "the store you find doesn't match the gep above it");
            // 在这里卡一个条件，如果向数组中存入的不是个常数，本循环中是不做的
            // debug半小时，发现store指令的op0是指令横向阅读的第二个操作数
            // printf("store op1 value = %d\n", store->getOp()[1]->getSymbolEntry()->getType()->toStr().c_str());
            // printf("store op1 value = %d\n", store->getOp()[1]->toStr().c_str());
            // printf("store op1 value = %d\n", store->getOp()[1]->getLabel());
            // printf("store op1 isConstant? = %d\n", store->getOp()[1]->getSymbolEntry()->isConstant());
            // printf("store op1 isTemporary? = %d\n", store->getOp()[0]->getSymbolEntry()->isTemporary());
            // printf("store op1 isVariable? = %d\n", store->getOp()[0]->getSymbolEntry()->isVariable());
            // getchar();
            if(!store->getOp()[1]->isConst())
            {
                vectorization_stage1 = false;
                break;
            }
            // 指示这条store指令生成含有向量化(右端常数情况)的汇编
            store->setAsmType(1);
            asmChange = 1;
            vectorization_type = 1;
            // Operand* op0 = ins->getOp()[0];
            // printf("binary op0 = %d\n", op0->getLabel());
            // printf("op0 getDst = %d\n", op0->getDst()->getLabel());
            // Instruction* op0_def = op0->getDef()->getDef()->getDef();
            // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
            // for(int i = 0; i < op0_def->getOp().size(); i ++)
            // {
            //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
            // }
            break;
        }
    }
    
    // return;
    // getchar();
    debugvec("8\n");
    // 向量化dst[i] = 0 和dst[i] = src[i]的两种情况是互斥的
    if(!vectorization_stage1)
    {
        // 上面循环的写法有遗漏，如果bodybb中有两条及以上gep指令，store会出现在最后一条gep之后
        // 上面的循环判断会将这种情况break掉
        // 下面通过def-use关系找到dst[i] = src[i]这种情况，需要满足的条件如下：
        
        debugvec("8-1\n");
        StoreInstruction* store_inbody = dynamic_cast<StoreInstruction*>(find_inst(Instruction::STORE, body_bb));
        // assert(store_inbody);
        if(vectorization_stage2 && !store_inbody)vectorization_stage2 = false;
        debugvec("8-2\n");
        if(store_inbody)assert(store_inbody->isStore());
        // conditino1: store指令的op1, op0都不是常数
        // condition2: store指令的op0(即dst)是一条GEP指令的dst, 如果它是一个全局变量（连数组都不是的那种），这里会报错，已修正
        if(vectorization_stage2 && !store_inbody->getOp()[0]->getDef())vectorization_stage2 = false;
        if(vectorization_stage2 && !store_inbody->getOp()[0]->getDef()->isGep())vectorization_stage2 = false;
        // getchar();
        GepInstruction* gep1_inbody;
        if(vectorization_stage2)gep1_inbody = dynamic_cast<GepInstruction*>(store_inbody->getOp()[0]->getDef());

        // condition3: store指令的op1(即src)是一条LOAD指令的dst
        // printf("store_inbody->getOp()[1] label = %d\n", store_inbody->getOp()[1]->getLabel());
        // display_instruction(store_inbody->getOp()[1]->getDef());
        debugvec("8-3\n");
        // printf("vectorization_stage2 = %d\n", vectorization_stage2);
        // printf("store_inbody = %d\n", store_inbody);
        // printf("vectorization_stage2 = %d\n", vectorization_stage2);
        if(!vectorization_stage2 || !store_inbody || !store_inbody->getOp()[1] 
            || !store_inbody->getOp()[1]->getDef()
            || !store_inbody->getOp()[1]->getDef()->isLoad())vectorization_stage2 = false;
        debugvec("8-4\n"); 
        LoadInstruction* load_inbody1 = nullptr;
        if(vectorization_stage2 && store_inbody && store_inbody->getOp()[1])load_inbody1 = dynamic_cast<LoadInstruction*>(store_inbody->getOp()[1]->getDef());
        // condition4: 这条LOAD指令的op1(即src)是一条GEP指令的dst(如此，保证双方都是数组)
        if(vectorization_stage2 && !load_inbody1->getOp()[1]->getDef()->isGep())vectorization_stage2 = false;
        GepInstruction* gep2_inbody;
        if(vectorization_stage2)gep2_inbody = dynamic_cast<GepInstruction*>(load_inbody1->getOp()[1]->getDef());
        // getchar();
        // condition5: 这两条GEP指令的index都等于binary指令的op1(即循环变量)
        int binaryop1_label = iter->getOp()[1]->getLabel();
        if(vectorization_stage2 && gep1_inbody->getOp()[2]->getLabel() != binaryop1_label)vectorization_stage2 = false;
        if(vectorization_stage2 && gep2_inbody->getOp()[2]->getLabel() != binaryop1_label)vectorization_stage2 = false;
        
        // (如此，保证数组下标是连续的，其实是op1加一个常数或者不变的变量也可以，后期优化)
        if(vectorization_stage2)vectorization_type = 2;

        debugvec("8-5\n");
        // 如果全部满足，指示这条store指令生成含有向量化(右端数组情况)的汇编
        if(vectorization_stage2){
            asmChange = 1;
            store_inbody->setAsmType(2);
        }
        debugvec("8-6\n");
        // 别忘了还要指示那条load指令生成含有向量化(右端数组情况)的汇编
        if(vectorization_stage2){
            asmChange = 1;
            load_inbody1->setAsmType(2);
        }
        debugvec("8-7\n");
        // ldr r4, [r2] --> vld1.u32 {q0}, [r2]!
        // str r4, [r2] --> vst1.u32 {q0}, [r2]!
    }

    // 如果上述条件有一条不满足，return,根本不做向量化的任何更改
    if(vectorization_stage1 == false && vectorization_stage2 == false)return;
    // getchar();
    debugvec("9\n");
    
    // return;
    // printf("vectorization modified code!\n");
    // 不能在这个循环之前就setOperand，因为这个循环里如果发现store指令存的不是常数，也会返回
    if(asmChange==1){
        // printf("asmChange==1\n");
        // 设置循环次数是否为4的整倍数的判断逻辑
        // getchar();
        // BasicBlock* bodybb_novec = body_bb->copybb1(func);
        // changeOperandLabel(bodybb_novec, body_bb);
        // // 调整GEP前load指令的dst避免寄存器分配出现问题
        // GepInstruction* gep_inbodybb_novec = dynamic_cast<GepInstruction*>(find_inst(Instruction::GEP, bodybb_novec));
        // Instruction* load_inbodybb_novec = gep_inbodybb_novec->getOp()[1]->getDef();
        // printf("load_inbodybb_novec = %d\n", load_inbodybb_novec);
        // getchar();
        // display_instruction(load_inbodybb_novec);
        // 调整循环累加变量
        iter->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));
        // display_instruction(cmp_inbody);
        Operand* iter_num = cmp_inbody->getOp()[2];
        // printf("iter_num label = %d\n", iter_num->getLabel());
        // getchar();
    debugvec("10\n");
    // return;

        BasicBlock* judgevec = new BasicBlock(func);
        Operand* mod_dst = new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel()));
        BinaryInstruction* mod = new BinaryInstruction(BinaryInstruction::MOD, mod_dst, iter_num, 
            new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)), judgevec);
        Operand* cmp_dst = new Operand(new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel()));
        CmpInstruction* cmp_injudge = new CmpInstruction(CmpInstruction::E, cmp_dst, mod_dst, 
            new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)), judgevec);
        CondBrInstruction* condbr_injudge = new CondBrInstruction(body_bb, bodybb_novec, cmp_dst, judgevec);

    debugvec("10-1\n");
        // 处理这段逻辑的前驱、后继关系
        // cond_bb --> judgevec
        BasicBlock* body_pred = nullptr;// 如果有多个，就会出问题
        for(BasicBlock* pred : body_bb->getPredBlock())
        {
            if(pred != body_bb)
            {
                pred->removeSucc(body_bb);
                pred->addSucc(judgevec);
                judgevec->addPred(pred);
                // body_bb->removeSucc(pred);
                body_pred = pred;
            }
        }
    debugvec("10-2\n");
        // body_pred = cond_bb;
        assert(body_pred != nullptr);
        // printf("body_pred no = %d\n", body_pred->getNo());
        // return;
        // judgevec --> body_bb, bodybb_novec
        judgevec->addSucc(body_bb);
        body_bb->addPred(judgevec);
        judgevec->addSucc(bodybb_novec);
        bodybb_novec->addSucc(bodybb_novec);
        bodybb_novec->addSucc(end_bb);
        bodybb_novec->addPred(judgevec);
    debugvec("10-3\n");
    // return;
        // 整理phi指令
        // UncondBrInstruction* uncond = find_inst(Instruction::UNCOND, cond_bb);
        setBranch_trueBranch(judgevec, body_pred);
        setBranch_trueBranch(bodybb_novec, bodybb_novec);
        PhiInstruction* phi_inbody = dynamic_cast<PhiInstruction*>(body_bb->begin());
        assert(phi_inbody);
        // printf("body_pred no = %d\n", body_pred->getNo());
        // printf("judgevec no = %d\n", judgevec->getNo());
        // phi_inbody->output_to_console();
        phi_inbody->changeSrcBlock(body_pred, judgevec);
        // phi_inbody->output_to_console();
    debugvec("10-4\n");
        // for(auto src : phi_inbody->getSrcs())
        // {
        //     if(src.first == body_pred)
        //     {
        //         printf("in bb == body_pred\n");
        //         BasicBlock* bb = src.first;
        //         bb = judgevec;
        //     }
        // }
        // phi_inbody->getSrcs().begin()->first = judgevec;
        // phi_inbody.src
        // phi_inbody->output_to_console();
        PhiInstruction* phi_inbody_nov = dynamic_cast<PhiInstruction*>(bodybb_novec->begin());
        assert(phi_inbody_nov);
    debugvec("10-5\n");
    // return;
    // printf("body_pred = %d, judgevec = %d\n", body_pred->getNo(), judgevec->getNo());
    //     phi_inbody_nov->output_to_console();

        // for (auto src : phi_inbody_nov->getSrcs()) {
        //     printf("before if\n");
        //     // if(src == nullptr)continue;
        //     printf("src = %d\n", src);
        //     // printf("src.first = %d\n", src.first->getNo());
        //     if (src.first == body_pred) {
        //         printf("in if1\n");
        //         Operand *temp = src.second;
        //         phi_inbody_nov->getSrcs().erase(src.first);
        //         phi_inbody_nov->getSrcs()[judgevec] = temp;
        //         printf("in if2\n");
        //     }
        // }

        phi_inbody_nov->changeSrcBlock(body_pred, judgevec);
        phi_inbody_nov->changeSrcBlock(body_bb, bodybb_novec);
        // phi_inbody_nov->output_to_console();
        // for(auto src : phi_inbody_nov->getSrcs())
        // {
        //     if(src.first == body_pred)
        //     {
        //         printf("in bb == body_pred\n");
        //         BasicBlock* bb = src.first;
        //         bb = judgevec;
        //     }
        // }
        // phi_inbody_nov->output_to_console();

        // for(BasicBlock* p : bodybb_novec->getPredBlock())
        // {
        //     printf("p No = %d\n", p->getNo());
        // }
        bodybb_novec->addPred(bodybb_novec);
        // printf("nodybb_novec = %d\n", bodybb_novec->getNo());
        body_bb->removePred(cond_bb);
        end_bb->addPred(bodybb_novec);
        // printf("asm==1 end\n");
        // printf("condbb no = %d\n", cond_bb->getNo());
        // return;
    debugvec("11\n");
        // getchar();
    }
    std::cout<<"yes vec "<< vectorization_type<<" done.\n";
    // displayBB(bodybb_novec);
    // getchar();
    return;

    // 目前为止，插入neon指令的工作已经完成
    // 但是运行时实际循环次数是不是4的倍数不好说，所以需要再写一个和原来很像的循环
    // 循环次数就是没有做完的那几次循环的个数
    // 思路是，在插向量化指令之前，先把原来的块全部深拷贝一遍√
    // 然后在下面的代码中改改寄存器号√
    // 还要处理寄存器和指令之间的def use dst关系
    // 修改跳转关系和块之间的前驱、后继关系√
    // 通过sub指令计算一下循环次数√
    // printf("condbb_copy label = %d\n", condbb_copy->getNo());
    // printf("bodybb_copy label = %d\n", bodybb_copy->getNo());
    // printf("endbb_copy label = %d\n", endbb_copy->getNo());
    // printf("tempbb1 label = %d\n", tempbb1->getNo());
    // printf("tempbb2 label = %d\n", tempbb2->getNo());

    
    // 1-1: 修正condbb_copy中的寄存器
    // displayBB(condbb_copy);
    // 需要插入sub指令计算新的循环变量值
    // Operand* iter_op1 = iter->getOp()[1];
    // // printf("iter op1 = %d\n", iter_op1->getLabel());
    // BinaryInstruction* newbinary = new BinaryInstruction(BinaryInstruction::SUB, 
    //     iter_op1, iter_op1, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));
    // // condbb_copy->insertFront(newbinary);
    // condbb_copy->insertBefore(newbinary, find_inst(Instruction::CMP, condbb_copy));
    // Instruction* newcmp_incond = find_inst(Instruction::CMP, condbb_copy);
    // // display_instruction(newcmp_incond);
    // newcmp_incond->setOperand(1, iter_op1);
    // CondBrInstruction* newbr_incond = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, condbb_copy));
    // // printf("newbr1 truebranch = %d, falsebranch = %d\n", newbr_incond->getTrueBranch()->getNo(), newbr_incond->getFalseBranch()->getNo());
    // newbr_incond->setTrueBranch(bodybb_copy);
    // newbr_incond->setFalseBranch(endbb_copy);
    // // printf("newbr2 truebranch = %d, falsebranch = %d\n", newbr_incond->getTrueBranch()->getNo(), newbr_incond->getFalseBranch()->getNo());

    // // 1-2: 修正bodybb_copy中的寄存器
    // CondBrInstruction* newbr_inbody = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, bodybb_copy));
    // newbr_inbody->setTrueBranch(tempbb1);
    // newbr_inbody->setFalseBranch(tempbb2);

    // // fixbug: 第一条load循环次数的指令下到汇编，不知为何没有从栈中拿[fp, #-4]，而是从[r0]，导致了段错误
    // // printf("cmp op2 = %d\n", find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getLabel());
    // // printf("inst = %d\n", find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getDef());
    // // getchar();
    // // Instruction* load_inbody = find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getDef();
    // // 这种获取方式是片面的，本来应该按照上面的def关系获取，但这里的def关系没有维护好
    // Instruction* load_inbody = find_inst(Instruction::CMP, bodybb_copy)->getPrev();
    // // assert(load_inbody->isLoad());
    // if(load_inbody->isLoad())
    // {
    //     // display_instruction(load_inbody);
    //     // printf("load_incody = %d\n", load_inbody);
    //     load_inbody->setOperand(0, new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())));
    //     find_inst(Instruction::CMP, bodybb_copy)->setOperand(2, load_inbody->getOp()[0]);
    // }
    // // getchar();

    // // displayBB(bodybb_copy);
    // // BinaryInstruction* bin = dynamic_cast<BinaryInstruction*>(find_inst(Instruction::BINARY, bodybb_copy));
    // // display_instruction(bin);
    // // printf("bin op2 value = %d\n", bin->getOp()[2]->getConstVal());

    // // 1-3: 向tempbb2中填充指令
    // dynamic_cast<UncondBrInstruction*>(find_inst(Instruction::UNCOND, tempbb2))->setBranch(endbb_copy);
    // // displayBB(tempbb2);
    // // BinaryInstruction* bin_t1 = new BinaryInstruction(BinaryInstruction::ADD, );

    // // 1-4: 修改endbb_copy中的寄存器
    // // 我觉得不用改了，直接跳end_bb吧
    // // displayBB(endbb_copy);
    // // 已同时完成生成指令和插入指定块
    // UncondBrInstruction* uncond_inend = new UncondBrInstruction(end_bb, endbb_copy);

    // // 1-5: 让原endbb的第一个前驱块不要直接跳endbb，而是跳到我们的补偿循环开始块condbb_copy
    // // printf("endbb prevblock[0] = %d\n", endbb->getPredBlock()[0]->getNo());
    // // printf("endbb prevblock[1] = %d\n", endbb->getPredBlock()[1]->getNo());//√
    // // printf("bodybb succblock[0] = %d\n", body_bb->getSuccBlock()[0]->getNo());
    // // printf("bodybb succblock[1] = %d\n", body_bb->getSuccBlock()[1]->getNo());//√
    // // displayBB(body_bb->getSuccBlock()[1]);
    // BasicBlock* p_tempbb2 = body_bb->getSuccBlock()[1];
    // dynamic_cast<UncondBrInstruction*>(find_inst(Instruction::UNCOND, p_tempbb2))->setBranch(condbb_copy);
    // // displayBB(body_bb->getSuccBlock()[1]);

    // // 1-6: 发现tempbb1还是得有
    // BinaryInstruction* bin_inbody = dynamic_cast<BinaryInstruction*>(find_inst(Instruction::BINARY, bodybb_copy));
    // BinaryInstruction* bin_t1 = new BinaryInstruction(BinaryInstruction::ADD, 
    //     bin_inbody->getOp()[1], bin_inbody->getOp()[0], new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)), tempbb1);
    // UncondBrInstruction* uncond_t1 = new UncondBrInstruction(bodybb_copy, tempbb1);
    // // displayBB(tempbb1);
    // // getchar();

    // // 1-7: 发现原tempbb2块也不能直接跳到condbb_copy
    // // 如果循环次数正好是4的倍数，这个方法会死循环
    // // 所以加一条icmp指令，比较循环上限和当前循环次数
    // // 如果是小于，说明有漏下的，需要调condbb_copy
    // // 如果是等于，说明不需要补加
    // // 不可能是大于，那样根本不会跳出循环
    // // 记得把指令插入块

    // // fix(sl段错误): load_pt2的找法是不全面的，bodybb里cmp指令前的一条指令不一定是load
    // // 目前的想法是，如果它这里没有load，那可能根本没有这样一条load
    // // 我们这里直接拿来用就可以，也不用去load
    
    // LoadInstruction* load_pt2 = nullptr;
    // if(find_inst(Instruction::CMP, body_bb)->getPrev()->isLoad())
    // {
    //     load_pt2 = new LoadInstruction(new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())),
    //         find_inst(Instruction::CMP, body_bb)->getPrev()->getOp()[1]);
    // }
    // Operand* cmp_pt2_src1 = load_pt2 == nullptr ? find_inst(Instruction::CMP, body_bb)->getOp()[2] : load_pt2->getOp()[0];
    // // wzr: 此处找的不一定对，万一bodybb里还有别的binary指令, 所以用def关系找
    // Operand* cmp_pt2_src2 = find_inst(Instruction::CMP, body_bb)->getOp()[1]->getDef()->getOp()[1];
    // CmpInstruction* cmp_pt2 = new CmpInstruction(CmpInstruction::L, 
    //     new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())),
    //     cmp_pt2_src1, cmp_pt2_src2);
    // CondBrInstruction* cond_pt2 = new CondBrInstruction(condbb_copy, end_bb, cmp_pt2->getOp()[0]);
    // // p_tempbb2->clearInstructions();
    // if(load_pt2 != nullptr)
    //     p_tempbb2->insertBack(load_pt2);
    // p_tempbb2->insertBack(cmp_pt2);
    // p_tempbb2->insertBack(cond_pt2);
    // p_tempbb2->remove(find_inst(Instruction::UNCOND, p_tempbb2));
    // // displayBB(p_tempbb2);
    // // displayBB(p_tempbb2);
    // // getchar();
    // // p_tempbb2->insertBefore();

    // // 到此为止新块是无法被显示在中间代码/汇编中的
    // // 2: 整理块之间的前驱、后继关系
    // // 2-1: 原temp2增加跳到新condbb_copy的关系
    // // p_tempbb2->removeSucc(end_bb);
    // // end_bb->removePred(p_tempbb2);
    // p_tempbb2->addSucc(condbb_copy);
    // condbb_copy->addPred(p_tempbb2);

    // // 2-2: 新condbb_copy添加和新bodybb_copy的关系
    // condbb_copy->addSucc(bodybb_copy);
    // bodybb_copy->addPred(condbb_copy);
    
    // // 2-3: 新condbb_copy添加和新endbb_copy之间的关系
    // condbb_copy->addSucc(endbb_copy);
    // endbb_copy->addPred(condbb_copy);

    // // 2-4: 新bodybb_copy添加和tempbb1的关系
    // bodybb_copy->addSucc(tempbb1);
    // bodybb_copy->addPred(tempbb1);
    // tempbb1->addPred(bodybb_copy);
    // tempbb1->addSucc(bodybb_copy);

    // // 2-5: 新bodybb_copy添加和tempbb2的关系
    // bodybb_copy->addSucc(tempbb2);
    // tempbb2->addPred(bodybb_copy);

    // // 2-6: 新tembb2添加和新endbb_copy的关系
    // tempbb2->addSucc(endbb_copy);
    // endbb_copy->addPred(tempbb2);

    // // 2-7: 新endbb_copy添加和原end_bb的关系
    // endbb_copy->addSucc(end_bb);
    // end_bb->addPred(endbb_copy);
    
    if(vectorization_stage1)vectorization_type = 1;
    else if(vectorization_stage2)vectorization_type = 2;
    // printf("vectorization%d end\n", vectorization_type);
    return;
    getchar();
    std::vector<Instruction*> sitofps;
    // for(int h = 0; h < iternum; h ++)
    // {
    //     old2new.clear();
        
    //     #ifdef DEBUG0429
    //         std::cout<<"below transfer body_bb for insert\n";
    //     #endif
    //     //std::cout<<"iter1 = "<<iter<<"\n";
    //     body_bb->insertBefore(iter, comparer);
    //     body_bb->remove(iter);
    //     iter = comparer->getPrev();
    //     // std::cout<<"iter2 = "<<iter<<"\n";
    //     // 把外层循环i的值存回栈里
    //     // new StoreInstruction(dst, src, new_bb);
    //     // printf("body_bb next gep:\n");
    //     // for(int i = 0; i < body_bb->begin()->getNext()->getOp().size(); i ++)
    //     // {
    //     //     printf("operand%d = %d\n", i, body_bb->begin()->getNext()->getOp()[i]->getLabel());
    //     // }
    //     // 找到body块中的fsub指令，确认一下是否在copy时没有拷贝上浮点数信息
    //     Instruction* fsub = nullptr;
    //     Instruction* mysitofp = nullptr;
    //     for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isGep())
    //         // //else if(ins->isCall())
    //         // {
    //         //     // std::cout<<"isgep iscall 1\n";
    //         //     Operand* d = ins->getOp()[0];
    //         //     printf("0710: gep1 operands\n");
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     mysitofp = ins;
    //         //     printf("mysitofp = ins;\n");
    //         // }
    //         // printf("ins = %s\n", ins->getInstName().c_str());
    //         // printf("ins opcode = %d\n", ins->getOpcode());
    //         // for(int i = 0; i < ins->getOp().size(); i ++)
    //         // {
    //         //     printf("operand%d = %d\n", i, ins->getOp()[i]->getLabel());
    //         //     printf("operand%d type = %s\n", i, ins->getOp()[i]->getType()->toStr().c_str());
    //         // }
    //         if(ins->isBin() && ins->getOpcode() == 0)
    //         {
    //             fsub = ins;
    //         }
    //         // }
    //         // printf("is sitofp(out) = %d\n", ins->isSitofp());
    //         //if(ins == iter)std::cout<<"is iter1\n";
    //         //if(ins->isGep())std::cout<<"is gep1\n";
    //         // if(ins->isCall())
    //         // {
    //         //     std::cout<<"call dst = "<<ins->getDef()->getLabel()<<" call dst = "<<dynamic_cast<CallInstruction*>(ins)->dst->getLabel()<<"\n";
    //         // }
    //         if(ignored_ins.find(ins) != ignored_ins.end())
    //         {
    //             continue;
    //         }
    //         if(ins == iter || ins->isCond() || ins->isUncond())
    //         {
    //             continue;
    //         }
    //         // std::cout<<"??? instr name = "<<ins->getInstName()<<"\n";
    //         Instruction* new_ins = ins->copy(ins, new_bb);
    //         // std::cout<<"new>>>\n";
    //         old2new.insert({ins, new_ins});
    //         // std::cout<<"insert>>>\n";
    //         if(new_ins->isSitofp())
    //         {
    //             // printf("insert to sitofps\n");
    //             sitofps.push_back(new_ins);
    //         }

    //         // printf("new ins from copy");
    //         // printf("new ins = %s\n", old2new[ins]->getInstName().c_str());
    //         // printf("new ins opcode = %d\n", old2new[ins]->getOpcode());
    //         // for(int i = 0; i < old2new[ins]->getOp().size(); i ++)
    //         // {
    //         //     printf("operand%d = %d\n", i, old2new[ins]->getOp()[i]->getLabel());
    //         //     printf("operand%d type = %s\n", i, old2new[ins]->getOp()[i]->getType()->toStr().c_str());
    //         // }
    //     }

    //     // printf("mysitofp = %d\n", mysitofp);
    //     // 看看fsub转换成=的指令是不是浮点指令
    //     // printf("fsub = %d\n", fsub);
    //     // printf("fsub insname 1 = %s\n", fsub->getInstName().c_str());
    //     // printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //     // printf("fsub op0 type 1 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //     // printf("old fsub op0 type 1 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());

    //     #ifdef DEBUG0429
    //         std::cout<<"below transfer body_bb for exchange operand\n";
    //     #endif
    //     bool flag = false;
    //     //start -= accumulator;

        
    //     for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     // mysitofp = ins;
    //         //     printf("fsub 1 = %d\n", ins);
    //         //     printf("fsub 1 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 3 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 3 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 3 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }
    //         // printf("is sitofp(out) = %d\n", ins->isSitofp());
    //         //if(ins == iter)std::cout<<"is iter2\n";
    //         //if(ins->isGep())std::cout<<"is gep2\n";
    //         if(ignored_ins.find(ins) != ignored_ins.end())
    //         {
    //             continue;
    //         }
    //         if(ins == iter)
    //         {
    //             start += accumulator;
    //             //std::cout<<"start2 = "<<start<<"\n";
    //             continue;
    //         }
    //         else if(ins->isCond() || ins->isUncond())
    //         {
    //             continue;
    //         }
    //         else if(ins->isPhi())
    //         {
    //             continue;
    //         }
    //         else if(ins->isGep())
    //         //else if(ins->isCall())
    //         {
    //             // std::cout<<"isgep iscall 1\n";
    //             Operand* d = ins->getOp()[0];
    //             // printf("0710: gep operands\n");
    //             // for(int i = 0; i < ins->getOp().size(); i ++)
    //             // {
    //             //     printf("operand%d = %d\n", i, ins->getOp()[i]->getLabel());
    //             // }
    //             // std::cout<<"== "<<d->getType()->toStr()<<"\n";
                
    //             // Type* type = TypeSystem::floatType;
    //             Type* type = TypeSystem::intType;
    //             auto tmp = dynamic_cast<PointerType*>(d->getType());
    //             d = new Operand(new TemporarySymbolEntry(new PointerType(tmp->getType()), SymbolTable::getLabel()));
    //             //std::cout<<"setOperand 1\n";
    //             old2new[ins]->setOperand(0, d);
    //             // std::cout<<"isgep iscall 2\n";
    //         }
            
            
    //         #ifdef DEBUG0429
    //                 std::cout<<"ins op size = "<<ins->getOp().size()<<"\n";
    //         #endif
    //         if(ins->isStore() && ins->getPrev()->isGep() && (ins->getPrev()->getDef()->getUse()[0]) == ins)
    //         {
    //             //std::cout<<"setOperand 2\n";
    //             old2new[ins]->setOperand(0, old2new[ins->getPrev()]->getDef());
    //             //old2new[ins]->setOperand(1, old2new[ins->getPrev()]->getDef());
    //             //old2new[ins]->getDef()->getSymbolEntry()->setType(TypeSystem::intType);
    //             //continue;
    //             // std::cout<<"old2new[ins->getPrev()]->getDef() = "<<old2new[ins->getPrev()]->getDef()->toStr()<<"\n";
    //             // std::cout<<"old2new[ins->getPrev()]->getDef() = "<<old2new[ins->getPrev()]->getDef()->getType()->toStr()<<"\n";
    //             //std::cout<<"ins.getprev.getdef label = "<<old2new[ins->getPrev()]->getDef()->getLabel()<<"\n";
    //         }
    //         else if(ins->isLoad() && ins->getPrev()->isGep() && (ins->getPrev()->getDef()->getUse()[0]) == ins)
    //         {
    //             // old2new[ins]->setOperand(0, old2new[ins->getPrev()]->getDef());
    //             Type* tmptype = ins->getOp()[1]->getType();
    //             if(!tmptype->isPtr())
    //             {
    //                 assert(0 && "load operand1(src) type is not PTR!");
    //             }
    //             // dynamic_cast<PointerType*>(tmptype)->getType()->isFloat();
    //             if((dynamic_cast<PointerType*>(tmptype))->getType()->isInt()){
    //                 tmptype = TypeSystem::intType;
    //             }
    //             else if((dynamic_cast<PointerType*>(tmptype))->getType()->isFloat()){
    //             // printf("here!\n");
    //                 tmptype = TypeSystem::floatType;
    //             }
    //             Operand* newope = new Operand(new TemporarySymbolEntry(tmptype, SymbolTable::getLabel()));
    //             Operand* oldope = old2new[ins]->getOp()[0];
    //             // 拷贝def/use关系
    //             newope->setDef(ins);
    //             newope->addUse(old2new[ins->getNext()]);
    //             // newope->addUse(old2new[ins]->getNext());
    //             // printf("adduse who? %s\n", old2new[ins]->getNext()->getInstName().c_str());
    //             // printf("its operand1 is %d\n", old2new[ins]->getNext()->getOp()[1]->getLabel());
    //             // printf("oldope is %d\n", oldope->getLabel());

    //             old2new[ins]->setOperand(0, newope);
    //             // printf("ins operand1 : %d, %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //             // printf("ins operand2 : %d, %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //             // // printf("ins operand3 : %d\n", ins->getOp()[2]->getLabel());

    //             // printf("old2new ins operand1 : %d, %s\n", old2new[ins]->getOp()[0]->getLabel(), old2new[ins]->getOp()[0]->getType()->toStr().c_str());
    //             // printf("old2new ins operand2 : %d, %s\n", old2new[ins]->getOp()[1]->getLabel(), old2new[ins]->getOp()[1]->getType()->toStr().c_str());
    //             // printf("old2new ins operand3 : %d\n", old2new[ins]->getOp()[2]->getLabel());

    //             // printf("load next = %s\n", ins->getNext()->getInstName().c_str());
    //             // printf("load next is sitofp = %d\n", ins->getNext()->isSitofp());
    //             // printf("sitofp op0 = %d, op1 = %d\n", ins->getNext()->getOp()[0]->getLabel(), ins->getNext()->getOp()[1]->getLabel());
    //         }
            
    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 4 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 4 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 4 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }

    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     printf("fsub 2 = %d\n", ins);
    //         //     printf("fsub 2 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
            
    //         for(unsigned i = 1; i < ins->getOp().size(); i ++)
    //         {
    //             if(ins->isGep() && i == 1)
    //             {
    //                 if(ins->getOp()[1]->getDef() == nullptr)continue;
    //                 if(ins->getOp()[1]->getDef()->isGep())
    //                 {
    //                     // std::cout<<"gep but not the first\n";
    //                     old2new[ins]->setOperand(1, old2new[ins->getOp()[1]->getDef()]->getOp()[0]);
    //                 }
    //             }
                
    //             Instruction* ope = ins->getOp()[i]->getDef();
    //             if(ope == nullptr)
    //             {
    //                 //std::cout<<"continue\n";
    //                 continue;
    //             }
    //             if(ins->getOp()[i] == phi->getDef() || ope == iter)
    //             {
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch 1\n";
    //                 // old2new[ins]->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::floatType, start)));
    //                 old2new[ins]->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::constIntType, start)));
    //             }
    //             else if(old2new.find(ope) != old2new.end())
    //             {
    //                 #ifdef DEBUG0429
    //                     std::cout<<"branch old2new.find(ope) != old2new.end()\n";
    //                 #endif
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch2\n";
    //                 // printf("is sitofp = %d\n", ins->isSitofp());
    //                 //std::cout<<"setOperand 4\n";
    //                 old2new[ins]->setOperand(i, old2new[ope]->getOp()[0]);
    //                 if(ins->isStore() && i == 1 && ins->getPrev()->isGep())
    //                 {
    //                     // printf("gep before store op1 type = %s\n", ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->toStr().c_str());
    //                     assert(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->isPtr() && "gep op1 is not pointer type!! will cause nullptr fault!!");
    //                     // printf("isfloat? %d\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isFloat());
    //                     PointerType* mytype = dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType());
    //                     if(mytype->isPtr())
    //                     {
    //                         Type* mytype2 = mytype->getType();
    //                         if(mytype2->isArray())
    //                         {
    //                             // printf("in array branch\n");
    //                             if(dynamic_cast<ArrayType*>(mytype2)->getElementType()->isFloat())
    //                             {
    //                                 // printf("in array1 branch\n");
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else if(dynamic_cast<ArrayType*>(mytype2)->getElementType()->isInt())
    //                             {
    //                                 // printf("in array2 branch\n");
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                                 // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else
    //                             {
    //                                 printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                                 assert(0 && "not int type and not float type");
    //                             }
    //                         }
    //                         else
    //                         {

    //                             if(dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isFloat())
    //                             {
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else if(dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isInt())
    //                             {
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                                 // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);

    //                             }
    //                             else
    //                             {
    //                                 printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                                 assert(0 && "not int type and not float type");
    //                             }
    //                         }
    //                     }
    //                     else
    //                     {
    //                         assert(0 && "gep op1 type is not ptr");
    //                     }
    //                     // else if(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->isArray())
    //                     // {
    //                     //     printf("in array branch\n");
    //                     //     if(dynamic_cast<ArrayType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getElementType()->isFloat())
    //                     //     {
    //                     //         old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                     //     }
    //                     //     else if(dynamic_cast<ArrayType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getElementType()->isInt())
    //                     //     {
    //                     //         old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                     //         // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                     //     }
    //                     //     else
    //                     //     {
    //                     //         printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                     //         assert(0 && "not int type and not float type");
    //                     //     }
    //                     // }
    //                 }
    //                     // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                 // std::cout<<"old2new[ins]->getOp()[i] = "<<old2new[ins]->getOp()[i]->getType()->toStr()<<"\n";
    //                 // std::cout<<"old2new[ins]->getOp()[i] = "<<old2new[ins]->getOp()[i]->toStr()<<"\n";
    //                 old2new[ope]->getOp()[0]->addUse(old2new[ins]);
    //             }
    //             else
    //             {
    //                 #ifdef DEBUG0429
    //                                 std::cout<<"branch else\n";
    //                 #endif
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch3\n";
    //                 // printf("is sitofp = %d\n", ins->isSitofp());
    //                 //std::cout<<"setOperand 5\n";
    //                 old2new[ins]->setOperand(i, ope->getOp()[0]);
    //                 ope->getOp()[0]->addUse(old2new[ins]);
    //             }
    //             // std::cout<<"small loop end\n";
    //         }
    //             // std::cout<<"small loop end 2\n";
    //         // if(ins->isSitofp() && ins->getPrev()->isLoad())
    //         // {
    //         //     printf("sitofp op0 = %d, op1 = %d\n", ins->getOp()[0]->getLabel(), ins->getNext()->getOp()[1]->getLabel());
    //         //     printf("sitofp new op0 = %d, op1 = %d\n", old2new[ins]->getOp()[0]->getLabel(), old2new[ins]->getNext()->getOp()[1]->getLabel());
    //         // }

    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 5 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 5 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 5 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     printf("fsub 3 = %d\n", ins);
    //         //     printf("fsub 3 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
    //     }
        
    //     // 检验sitofp的参数类型
    //     // for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     // {
    //     //     if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //     //     {
    //     //         printf("fsub 4 = %d\n", ins);
    //     //         printf("fsub 4 insname 3 = %s\n", ins->getInstName().c_str());
    //     //         printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //     //         printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //     //     }
    //     // }
    //     // 看看fsub转换成的指令是不是浮点指令
    //     // printf("fsub = %d\n", fsub);
    //     // printf("fsub insname 2 = %s\n", fsub->getInstName().c_str());
    //     // printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //     // printf("fsub op0 type 2 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //     // printf("old fsub op0 type 2 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //     // assert(mysitofp != nullptr);
    //     // if(mysitofp->isSitofp() && mysitofp->getOp()[0]->getLabel() == 68)
    //     // {
    //     //     printf("mysitofp 1 = %d\n", mysitofp);
    //     //     printf("mysitofp 1 insname 3 = %s\n", mysitofp->getInstName().c_str());
    //     //     printf("mysitofp op0 label = %d, type = %s\n", mysitofp->getOp()[0]->getLabel(), mysitofp->getOp()[0]->getType()->toStr().c_str());
    //     //     printf("mysitofp op1 label = %d, type = %s\n", mysitofp->getOp()[1]->getLabel(), mysitofp->getOp()[1]->getType()->toStr().c_str());
    //     // }
        
    //     #ifdef DEBUG0429
    //         std::cout<<"after transfer body_bb for exchange\n";
    //     #endif
    //     for(Instruction* ins = new_bb->begin(); ins != new_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isCall())
    //         // {
    //         //     std::cout<<"call dst = "<<ins->getDef()->getLabel()<<" call dst = "<<dynamic_cast<CallInstruction*>(ins)->dst->getLabel()<<"\n";
    //         // }
    //     }
    // }
    // // for(Instruction* ins : sitofps)
    // {
    //     printf("one sitofps ins op0 = %d, op1 = %d\n", ins->getOp()[0]->getLabel(), ins->getOp()[1]->getLabel());
    // }
    #ifdef DEBUG0429
    std::cout<<"after while(start < end)\n";
    #endif
    // std::cout<<"stage4\n";
    // old2new[iter] = new BinaryInstruction(BinaryInstruction::ADD, iter->getDef(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)),
    //                                    new Operand(new ConstantSymbolEntry(TypeSystem::intType, accumulator)), new_bb);

    old2new.clear();
    std::unordered_map<Instruction*, Instruction*> old2new_;
    #ifdef DEBUG0429
    #endif
    Instruction* outbb_phi;
    Operand* outbb_phi_dst;
    // for(Instruction* ins = outBB->begin(); ins != outBB->end(); ins = ins->getNext())
    // {
    // // std::cout<<"ins = "<<ins<<"\n";
    //     // printf("is sitofp(outbb) = %d\n", ins->isSitofp());
    //     if(ins->isPhi()){
    //         outbb_phi = ins;
    //         outbb_phi_dst = ins->getDef();
    //         //std::cout<<"outbb_phi_dst = "<<outbb_phi_dst->toStr()<<"\n";
    //     }
    // // std::cout<<"ins.type = "<<ins->getInstName()<<"\n";
    // // std::cout<<"ins.ops = "<<ins->getOp().size()<<"\n";
    //     for(unsigned i = 0; i < ins->getOp().size(); i ++)
    //     {
    // // std::cout<<"breakpoint0\n";
    //         if(ins->getOp()[i] == nullptr)
    //         {
    //             continue;
    //         }
    //         Instruction* ope = ins->getOp()[i]->getDef();
    //         if(ope == nullptr)
    //         {
    // // std::cout<<"breakpoint1\n";
    //             #ifdef DEBUG0429_terminal
    //                         std::cout<<"ope == nullptr\n";
    //             #endif
    //             continue;
    //         }
    //         if(old2new_.find(ope) != old2new_.end())
    //         {
    // // std::cout<<"breakpoint2\n";
    //             ins->setOperand(i, old2new_[ope]->getOp()[0]);
    //         }
    //         else if(ope->isPhi())
    //         {
    // // std::cout<<"breakpoint3\n";
    //             ins->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::constIntType, start + accumulator)));
    //         }
    // // std::cout<<"breakpoint4\n";
    //     }
    // }

    // printf("bodybb = %d\n", body_bb->getNo());
    // printf("condbb label = %d\n", condbb->getNo());
    // printf("bodybb label = %d\n", bodybb->getNo());
    // wzr!!: 这里下面的getPredBlock()直接取[0]是有可能导致问题的
    BasicBlock* mtempbb = condbb->getPredBlock()[0];
    BasicBlock* mtembbb_prev = mtempbb->getPredBlock()[0];
    // printf("mtempbb label = %d\n", mtempbb->getNo());
    // for(Instruction* ins = bodybb->begin(); ins != bodybb->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // if(ins->isLoad())
    //     // {
    //     //     printf("ins op0 = %d\n", ins->getOp()[0]->getLabel());
    //     //     printf("ins op1 = %d\n", ins->getOp()[1]->getLabel());
    //     //     // printf("ins op2 = %d\n", ins->getOp()[2]->getLabel());
    //     //     // printf("ins op3 = %d\n", ins->getOp()[3]->getLabel());
    //     // }
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     if(ins->isBin())
    //     {
    //         Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());

    //         // 补一个alloca
    //         // wzr!!: 不知道初始化alloca指令的第二个参数传对没
    //         AllocaInstruction* alloca_j = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // func->getEntry()->insertFront(alloca_j);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     // printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }
    //         // printf("accumulator = %d\n", accumulator);
    //         // printf("start = %d\n", start);
    //         // new StoreInstruction(op0->getDst(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)), new_bb);
    //     }
    // }

    // printf("body_bb next gep:\n");
    // for(int i = 0; i < body_bb->begin()->getNext()->getOp().size(); i ++)
    // {
    //     printf("operand%d = %d\n", i, body_bb->begin()->getNext()->getOp()[i]->getLabel());
    // }

    // printf("below traverse tempbb_prev, as 299\n");
    // for(Instruction* ins = mtembbb_prev->begin(); ins != mtembbb_prev->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // if(ins->isLoad())
    //     // {
    //     //     printf("ins op0 = %d\n", ins->getOp()[0]->getLabel());
    //     //     printf("ins op1 = %d\n", ins->getOp()[1]->getLabel());
    //     //     // printf("ins op2 = %d\n", ins->getOp()[2]->getLabel());
    //     //     // printf("ins op3 = %d\n", ins->getOp()[3]->getLabel());
    //     // }
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     if(ins->isBin())
    //     {
    //         // Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());

    //         // 补一个alloca
    //         // wzr!!: 不知道初始化alloca指令的第二个参数传对没
    //         // AllocaInstruction* alloca_j = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // func->getEntry()->insertFront(alloca_j);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }
    //         // printf("accumulator = %d\n", accumulator);
    //         // printf("start = %d\n", start);
    //         // new StoreInstruction(op0->getDst(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)), new_bb);
    //     }
    // }

    // Operand* mop2 = body_bb->begin()->getNext()->getOp()[2];
    // Operand* mop2 = nullptr;
    // for(Instruction* mins = body_bb->begin(); mins != body_bb->end(); mins = mins->getNext())
    // {
    //     // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //     // printf("mins = %s\n", mins->getInstName().c_str());
    //     if(mins->isGep() && !mins->getNext()->isGep())
    //     {
    //         if(mins->getPrev()->isGep())
    //         {
    //             // printf("mop2 branch1\n");
    //             mop2 = mins->getPrev()->getOp()[2];
    //         }
    //         else
    //         {
    //             // printf("mop2 branch2\n");
    //             mop2 = mins->getOp()[2];
    //         }
    //         // printf("in!!\n");
    //         // mtempbb->insertBefore(i_str, mins);
    //         break;
    //     }
    // }
    // assert(mop2 != nullptr);
    // printf("mop2 = %d\n", mop2->getLabel());
    // printf("traverse end_bb, find i's addr\n");
    LoadInstruction* i_load = nullptr;
    Instruction* i_binary = nullptr;
    // printf("end_bb no = %d\n", end_bb->getNo());
    // for(Instruction* ins = end_bb->begin(); ins != end_bb->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // printf("op size = %d\n", ins->getOp().size());
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         if(ins->getOp()[i] == nullptr)
    //         {
    //             // printf("op%d == nullptr, next\n", i);
    //             continue;
    //         }
    //         // assert(0 && "ins->getOp()[i] == nullptr");
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     // printf("after print ops\n");
    //     if(ins->isBin())
    //     {
    //         Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // assert(op0->getDst() != nullptr);
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());
    //         if(op0->getDst() == nullptr)
    //         {
    //             break;
    //         }
    //         //wzr !!
    //         // AllocaInstruction* alloca_i = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // printf("func entrybb = %d\n", func->getEntry()->getNo());
    //         // func->getEntry()->insertFront(alloca_i);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }

    //         // printf("mop2 label = %d\n", mop2->getLabel());
    //         // printf("mop2 dst = %d\n", mop2->getDst());
    //         // printf("nextline\n");

    //         // StoreInstruction* i_str = new StoreInstruction(mop2->getDst(), mop2, nullptr);
    //         StoreInstruction* i_str = new StoreInstruction(op0->getDst(), mop2, nullptr);
    //         // mtempbb->insertFront(i_str);
    //         // printf("mtempbb no = %d\n", mtempbb->getNo());
    //         for(Instruction* mins = mtempbb->begin(); mins != mtempbb->end(); mins = mins->getNext())
    //         {
    //             // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //             if(!mins->isPhi())
    //             {
    //                 // printf("in!!\n");
    //                 mtempbb->insertBefore(i_str, mins);
    //                 break;
    //             }
    //         }
    //         // for(Instruction* mins = mtempbb->end(); mins != mtempbb->begin(); mins = mins->getPrev())
    //         // {
    //         //     // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //         //     if(mins->isGep())
    //         //     {
    //         //         if(mins->getPrev()->isGep())
    //         //         {

    //         //         }
    //         //         else
    //         //         {

    //         //         }
    //         //         // printf("in!!\n");
    //         //         mtempbb->insertBefore(i_str, mins);
    //         //         break;
    //         //     }
    //         // }
    //         // printf("mtembb end def = %d\n", mtempbb->end()->getDef()->getLabel());
    //         // mtempbb->insertBefore(i_str, mtempbb->end());
            
    //         i_load = new LoadInstruction(op0, op0->getDst(), nullptr);

    //         ins->setOperand(1, op0);
    //     }
    //     if(ins->isBin())
    //     {
    //         i_binary = ins;
    //     }   
    // }
    // // std::cout<<"stage5\n";
    // 把i_load插入end_bb中binary指令前
    // if(i_binary != nullptr)
    // {
    //     end_bb->insertBefore(i_load, i_binary);
    // }

    // 向end_bb里插入从i_addr中load i值的语句


    //std::cout<<"body_bb->getSuccBlock().size()1 = "<<body_bb->getSuccBlock().size()<<"\n";
    // Instruction* binaryins = new BinaryInstruction(BinaryInstruction::ADD, outbb_phi_dst, iter->getDef(),
    //                                    new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)));
    // outBB->insertFront(binaryins);
    // outBB->remove(outbb_phi);

    //clear

    // cond_bb->clearInstructions();
    // body_bb->clearInstructions();

    //return;
    // UncondBrInstruction* uncondbr = new UncondBrInstruction(outBB, new_bb);
    // new_bb->addSucc(outBB);
    // outBB->addPred(new_bb);
    // for(BasicBlock* pred_cond : cond_bb->getPredBlock())
    // {
    //     if(pred_cond == body_bb)
    //     {
    // #ifdef DEBUG0429_terminal
    //         std::cout<<"pred_cond == body_bb\n";
    // #endif
    //         continue;
    //     }
    //     Instruction* b = pred_cond->getBrorRet();
    //     if(b->getInstName() == "COND")
    //     {
    //         CondBrInstruction* condbr = dynamic_cast<CondBrInstruction*>(b);
    //         if(condbr->getTrueBranch() == cond_bb)
    //         {
    //             condbr->setTrueBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
    //             //new_bb->removePred(pred_cond);
    //             new_bb->addPred(pred_cond);
    //         }
    //         else if(condbr->getFalseBranch() == cond_bb)
    //         {
    //             condbr->setFalseBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
                
    //             new_bb->addPred(pred_cond);
    //         }
    //     }
    //     else if(b->getInstName() == "UNCOND")
    //     {
    //         UncondBrInstruction* uncondbr = dynamic_cast<UncondBrInstruction*>(b);
    //         if(uncondbr->getBranch() == cond_bb)
    //         {
    //             uncondbr->setBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
    //             new_bb->addPred(pred_cond);
    //         }
    //     }
    // }

    

    // std::cout<<"stage6\n";

    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // if(cond_bb != nullptr)
    //     cond_bb->deleteAllRelation();
    // cond_bb->getParent()->remove(cond_bb);
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // cond_bb->removeSucc(oneloop->while_bb);
    // body_bb->removePred(cond_bb);
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    
    //new_bb->addPred(cond_bb->getPrevbb());
    //cond_bb->getPrevbb().addSucc(new_bb)


    // std::cout<<"depend relation begin\n";
    
    // cond_bb->getPredBlock().clear();

    //std::cout<<"body_bb->getSuccBlock().size() = "<<body_bb->getSuccBlock().size()<<"\n";
    // std::vector<BasicBlock*> temp;
    // for(BasicBlock* prev_cond : cond_bb->getPrevbb())
    // {
    //     // body_bb->removeSucc(succ_body);
    //     // succ_body->removePred(body_bb);
    //     //std::cout<<"bodybb succ_bb = "<<succ_body->getNo()<<"\n";
    //     prev_cond->addSucc(new_bb);
    //     new_bb->addPred(prev_cond);
    // }
    // for(BasicBlock* prev_cond : cond_bb->getPrevbb())
    // {
    //     prev_cond->removeSucc(cond_bb);
    // }
    
    // for(BasicBlock* succ_body : body_bb->getSuccBlock())
    // {
    //     end_bb->removePred(succ_body);
    // }
    // body_bb->getSuccBlock().clear();

    // std::cout<<"depend relation end\n";
    //body_bb->removeSucc(oneloop->end_bb);
    // end_bb->removePred(body_bb);

    // cond_bb->getParent()->remove(cond_bb);
    // body_bb->getParent()->remove(body_bb);

    // std::cout<<"!!\n";
    //body_bb->removePred(cond_bb);
    // cond_bb->removeSucc(body_bb);
    // std::cout<<"!!!\n";
    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    //outBB->removePred(cond_bb);
    // for(Instruction* ins = cond_bb->begin(); ins != cond_bb->end(); ins = ins->getNext())
    // {
    //     //ins.removeUseOfOps()
    // }
    // for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    // {
    //     //ins.removeUseOfOps()
    // }

    // func_list = unit->get_functions();

    //     std::vector<BasicBlock*> block_list = func->getBlockList();
    //     for(int j = 0; j < block_list.size(); j ++)
    //     {
    //         // for(Instruction* ins = block_list[j]->begin(); ins != block_list[j]->end(); ins = ins->getNext())
    //         // {
    //         //     if(ins->isGep())
    //         //     {
    //         //         //std::cout<<"gepinst9 = "<<ins<<"\n";
    //         //         ArrayType* type =
    //         //                 (ArrayType*)(((PointerType*)(ins->getOp()[1]->getType()))->getType());
    //         //         //std::cout<<"origin ayyaytype type = "<<type->toStr()<<"\n";
    //         //         Type* elementType = type->getElementType();
    //         //         //std::cout<<"origin elementtype = "<<elementType<<"\n";  
    //         //     }
    //         // }
    //         //std::cout<<"bb No = "<<block_list[j]->getNo()<<"\n";
    //     }
    //     //std::cout<<"block_list.size()"<<block_list.size()<<"\n";
    // //std::cout<<"=============================================\n";

    std::vector<BasicBlock*> BBs = func->getBlockList();
    
    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    //func->getBlockList().push_back(new_bb);
    // std::cout<<"BBs.size()1 = "<<BBs.size()<<"\n";
    
    // for (auto bb = func->getBlockList().begin(); bb != func->getBlockList().end();)
    // {
    //     if(*bb == cond_bb)
    //     {
    //         func->getBlockList().erase(bb);
    //         std::cout<<"after erase cond_bb\n";
    //         std::cout<<"bb No = "<<(*bb)->getNo()<<"\n";
    //         std::cout<<"func->getBlockList().size()2 = "<<func->getBlockList().size()<<"\n";
    //     }
    //     else if(*bb == body_bb)
    //     {
    //         func->getBlockList().erase(bb);
    //         std::cout<<"after erase body_bb\n";
    //         std::cout<<"bb No = "<<(*bb)->getNo()<<"\n";
    //         std::cout<<"func->getBlockList().size()3 = "<<func->getBlockList().size()<<"\n";
    //     }
    //     else
    //     {
    //         bb ++;
    //     }
    // }
    // std::cout<<"func->getBlockList().size()4 = "<<func->getBlockList().size()<<"\n";
    // std::cout<<"func->getBlockList().size() = "<<func->getBlockList().size()<<"\n";
    
    // func->remove(cond_bb);
    // func->remove(body_bb);
    
    // bool findPhi = false;
    // PhiInstruction* phi_next = nullptr;
    // BasicBlock* searchBB = end_bb;
    // while(!findPhi && searchBB != nullptr)
    // {
    //     std::cout<<"while\n";
    //     for(Instruction* ins = searchBB->begin(); ins != searchBB->end(); ins = ins->getNext())
    //     {
    //         if(ins->isPhi())
    //         {
    //             std::cout<<"isphi\n";
    //             findPhi = true;
    //             phi_next = dynamic_cast<PhiInstruction*>(ins);
    //             break;
    //         }
    //         else if(ins->isUncond())
    //         {
    //             searchBB = dynamic_cast<UncondBrInstruction*>(ins)->getBranch();
    //             std::cout<<"searchBB no = "<<searchBB->getNo()<<"\n";
    //         }
    //     }
    // }

    

    #ifdef DEBUG0429
    #endif

    std::cout<<"doVectorization end\n";
    // func_list = unit->get_functions();

    //     block_list = func->getBlockList();
    //     for(int j = 0; j < block_list.size(); j ++)
    //     {
    //         // for(Instruction* ins = block_list[j]->begin(); ins != block_list[j]->end(); ins = ins->getNext())
    //         // {
    //         //     if(ins->isGep())
    //         //     {
    //         //         //std::cout<<"gepinst9 = "<<ins<<"\n";
    //         //         ArrayType* type =
    //         //                 (ArrayType*)(((PointerType*)(ins->getOp()[1]->getType()))->getType());
    //         //         //std::cout<<"origin ayyaytype type = "<<type->toStr()<<"\n";
    //         //         Type* elementType = type->getElementType();
    //         //         //std::cout<<"origin elementtype = "<<elementType<<"\n";  
    //         //     }
    //         // }
    //         //std::cout<<"bb No = "<<block_list[j]->getNo()<<"\n";
    //     }
        //std::cout<<"block_list.size() final = "<<block_list.size()<<"\n";
    // std::cout<<"doVectorization check end\n";
    // func->getBlockList()->erase(cond_bb);
    // func->getBlockList()->erase(cond_bb);

    // cond_bb->clearInstructions();
    // body_bb->clearInstructions();

    // cond_bb->getParent()->remove(cond_bb);
    // body_bb->getParent()->remove(body_bb);
    // func.geten
    // func->getEntry()->insertBack(i_load);

}
